using System;

public class LaskeLuvut
{
    public static void Main()
    {
        int[] luvut = { 6, 1, 6 };

        int maara = Montako(luvut, 6);
        Console.WriteLine($"Kuutosia oli {maara} kpl");
        maara = Montako(new int[] { 1, 1, 1, 2, 1 }, 1);
        Console.WriteLine($"Ykkösiä oli {maara} kpl");
    }


    /// <summary>
    /// Aliohjelma tutkii, montako annettua lukua on taulukossa
    /// ja palauttaa sen.
    /// </summary>
    /// <param name="luvut">taulukko jossa on laskettavat luvut</param>
    /// <param name="luku">luku, jota etstiään taulukosta</param>
    /// <returns>montako haluttua lukua on taulukossa</returns>
    /// <example>
    /// <pre name="test">
    /// Montako(new int[]{3, 2, 1}, 2) === 1;
    /// Montako(new int[]{5, 5, 5}, 5) === 3;
    /// Montako(new int[]{2, 1, 3, 4}, 6) === 0;
    /// Montako(new int[]{}, 6) === 0;
    /// </pre>
    /// </example>
    // BYCODEBEGIN
    public static int Montako(int[] luvut, int luku)
    {
        int lkm = 0;
        foreach (int alkio in luvut)
        {
            if (alkio == luku) lkm++;
        }

        return lkm;
    }

    // BYCODEEND
}


