﻿using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author vesal
/// @version 24.10.2018
/// <summary>
/// Arvotaan lukkuja
/// </summary>
public class Arvonta
{
    /// <summary>
    /// Arvotaan lukuja taulukkoon
    /// </summary>
    public static void Main()
    {
        double[] t = ArvoLukuja(12, -3.1, 9.5);
        foreach (var d in t)
            Console.Write($"{d:0.00} ");
        Console.WriteLine();
    }


    /// <summary>
    /// Arvotaan n kappaletta reaalilukuja väliltä [x1, x2[
    /// </summary>
    /// <param name="n">Arvottavien lukujen lukumäärä</param>
    /// <param name="x1">alaraja arvotulle luvulle</param>
    /// <param name="x2">yläraja arvotulle luvulle</param>
    /// <returns>n alkion reaalilukutaulukko satunnaisia lukuja</returns>
    public static double[] ArvoLukuja(int n, double x1, double x2)
    {
        double[] t = new double[n];
        for (int i = 0; i < t.Length; i++)
        {
            double x = RandomGen.NextDouble(x1, x2);
            t[i] = x;
        }
        return t;
    }
}


public class RandomGen
{
    private static Random rand = new Random();
    public static double NextDouble(double min, double max) { return min + rand.NextDouble() * (max - min); }
}
