﻿using System;

/// @author vesal
/// @version 26.10.2018
/// <summary>
/// Lasketaan taulukoiden vastinalkioita yhteen
/// </summary>
public class Vastinalkiot
{
    /// <summary>
    /// Lasketaan yksiulotteisten taulukoiden vastainalkioita yhteen
    /// </summary>
    public static void Main()
    {
        double[] a = { 1, 2, 3, 4 };
        double[] b = { 5, 6, 7, 8 };
        double[] s = Summa(a, b);
        Console.WriteLine(String.Join(" ", s));
    }


    /// <summary>
    /// Lasketaan kaksi 1-úlotteista taulukoa yhteen ja palautetaan summa-taulukko.
    /// Jos taulukot ovat erikokoisia, toimitaan pienemmän koon mukaan.
    /// </summary>
    /// <param name="a">toinen laskettava</param>
    /// <param name="b">toinen laskettava</param>
    /// <returns>taulukkojen vastinalkioiden summataulukko</returns>
    /// <example>
    /// <pre name="test">
    ///    double[] a = { 1, 2, 3, 4 };
    ///    double[] b = { 5, 6, 7, 8 };
    ///    double[] s = Summa(a,b);
    ///    String.Join(" ", s) === "6 8 10 12";
    ///    String.Join(" ", Summa(a, new double[]{-2,-4})) === "-1 -2";
    ///    String.Join(" ", Summa(a, new double[0])) === "";
    /// </pre>
    /// </example>
    public static double[] Summa(double[] a, double[] b)
    {
        int n = Math.Min(a.Length, b.Length);
        double[] s = new double[n];
        for (int i = 0; i < n; i++)
            s[i] = a[i] + b[i];
        return s;
    }
}
