﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;

/// @author  Vesa Lappalainen
/// @version 17.09.2011
/// 
/// <summary>
/// Ohjelma piirtää viivoilla portaita
/// </summary>
public class Viivat : PhysicsGame
{

    const double VIIVANPITUUS = 80;
    const double VIIVANLEVEYS = 2;

    public override void Begin()
    {
        Level.Background.Color = Color.Black;
        Vector piste = new Vector(0, 0);
        Vector vaaka = new Vector(1, 0);
        Vector pysty = new Vector(0, 1);

        piste = PiirraViiva(this, piste, pysty);
        piste = PiirraViiva(this, piste, vaaka);
        piste = PiirraViiva(this, piste, pysty);
        piste = PiirraViiva(this, piste, vaaka);
        piste = PiirraViiva(this, piste, pysty);
        piste = PiirraViiva(this, piste, vaaka);
        piste = PiirraViiva(this, piste, -pysty);
        piste = PiirraViiva(this, piste, -pysty);
        piste = PiirraViiva(this, piste, -vaaka);

        PhysicsObject pallo = new PhysicsObject(5, 5, Shape.Circle);
        Add(pallo, 1);
        pallo.Color = Color.Red;

        Camera.ZoomToAllObjects(100);

        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }


    /// <summary>
    /// Piirretään pisteestä piste alkava viiva suuntaan suunta.
    /// Viivan 
    /// </summary>
    /// <param name="peli">peli johon viiva piirretään</param>
    /// <param name="piste">koordinaatti josta viiva alkaa</param>
    /// <param name="suunta">suunta johon viiva piirretään</param>
    /// <returns>piirretyn viivan päätepiste</returns>
    public static Vector PiirraViiva(PhysicsGame peli, Vector piste, Vector suunta)
    {
        double w = Math.Max(Math.Abs(suunta.X * VIIVANPITUUS), VIIVANLEVEYS);
        double h = Math.Max(Math.Abs(suunta.Y * VIIVANPITUUS), VIIVANLEVEYS);
        PhysicsObject viiva = new PhysicsObject(w, h);
        Vector siirto = new Vector(suunta.X * w, suunta.Y * h);
        viiva.Position = piste + 0.5 * siirto;
        peli.Add(viiva);
        return piste + siirto;
    }
}
