﻿using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author vesal
/// @version 17.11.2013
/// <summary>
/// Apuluokka Villen nosturiohjelman kirjoittamiseksi
/// </summary>
public class Robot
{
    /// <summary>
    /// Tähän voi kirjoittaa nosturiohjelmaa
    /// </summary>
    public static void Main()
    {
        RobotCommander rc = new RobotCommander();

    }

}


/// <summary>
/// Luokka Villen nosturin matkimiseksi.
/// Pidetään kirjaa nosturin paikasta ja siirtojen määrästä.
/// Jokaisen siirron kohdalla tulostetaan nosturin tilanne.
/// Metodien nimet ovat pienillä kirjaimilla, koska Villen
/// nosturi on tehty Javalla ja Javassa on tapana kirjoittaa nimet pienellä.
/// </summary>
public class RobotCommander
{
    private int siirtoja = 0;
    private int x = 0;
    private int y = 0;
    private bool kiinni = false;

    /// <summary>
    /// Alustetaan nosturi
    /// </summary>
    /// <param name="x">nosturin alkupaikka</param>
    /// <param name="y">nosturin alkupaikka</param>
    public RobotCommander(int x = 0, int y = 0)
    {
        this.x = x;
        this.y = y;
        Tulosta("alustus");
    }


    /// <summary>
    /// Nostetaan magneettia pykälä ylöspäin
    /// </summary>
    public void up()
    {
        siirtoja++;
        y++;
        Tulosta("^");
    }


    /// <summary>
    /// Viedään magnettiia pyklälä eteenpäin
    /// </summary>
    public void extend()
    {
        siirtoja+=2;
        x++;
        Tulosta("->");
    }


    /// <summary>
    /// Vedteään magneettia pykälä taaksepäin
    /// </summary>
    public void withdraw()
    {
        siirtoja+=2;
        x--;
        Tulosta("<-");
    }


    /// <summary>
    /// Lasketaan magneettia pykälä alaspäin
    /// </summary>
    public void down()
    {
        siirtoja++;
        y--;
        Tulosta("v");
    }


    /// <summary>
    /// Tartutaan kiinni kohdalla olevaan laatikkoon
    /// </summary>
    public void grab()
    {
        siirtoja++;
        kiinni = true;
        Tulosta("kiinni");
    }


    /// <summary>
    /// Päästetään irti laatikosta
    /// </summary>
    public void drop()
    {
        siirtoja++;
        kiinni = false;
        Tulosta("irti");
    }


    /// <summary>
    /// Tulostetaan nosturin tilanne
    /// </summary>
    /// <param name="msg">viesti joka tulee tilanteen jälkeen</param>
    public void Tulosta(string msg = "")
    {
        Console.WriteLine(ToString() + " " + msg);
    }


    /// <summary>
    /// Nosturin tiedot merkkijonona
    /// </summary>
    /// <returns>tiedot merkkijonona</returns>
    /// <example>
    /// <pre name="test">
    ///    RobotCommander rc = new RobotCommander(5,7);
    ///    rc.ToString() === "  0: (5,7) False";
    ///    rc.up();
    ///    rc.ToString() === "  1: (5,8) False";
    ///    rc.grab();
    ///    rc.ToString() === "  2: (5,8) True ";
    /// </pre>
    /// </example>
    public override string ToString()
    {
        return String.Format("{0,3}: ({1},{2}) {3,-5}", siirtoja, x, y, kiinni);
    }
}