﻿using System;
using System.Collections.Generic;
using MinJypeli;

namespace Demo7
{
    /// @author  Vesa Lappalainen
    /// @version 26.10.2019
    /// <summary>
    /// Käsitellään pistejoukkoja
    /// </summary>
    public class Pisteet
    {
        private const double x1 = -5;
        private const double x2 = 20;
        private const double y1 = -5;
        private const double y2 = 20;


        /// <summary>
        /// Alustetaan pistetaulukko ja kysellään käyttäjältä pisteitä ja tulostetaan
        /// aina sitä lähimmän pisteen koordinaatit.
        /// Ohjelma loppuu kun käyttäjä vastaa pelkän return.
        /// </summary>
        public static void Main()
        {
            Vector[] pisteet;
            pisteet = ArvoPisteet(10, x1, y1, x2, y2);

            TulostaPisteet(pisteet, 5);

            while (true)
            {
                Console.Write("Anna pisteen koordinaatti muodossa (x,y) >");
                string s = Console.ReadLine();
                if (s == null || s == "") break;
                Vector piste = Vector.Parse(s);
                TulostaLahin(pisteet, piste);
            }
        }


// BYCODEBEGIN

        /// <summary>
        /// Tulostetaan pisteet muodossa (1,2) (9,2) (2,9) (12,5).
        /// Riville tulostuu korkeintaan maxRivilla pistettä sitten vaihdetaan riviä.
        /// </summary>
        /// <param name="pisteet">tulostettavien pisteiden koordinaatit</param>
        /// <param name="maxRivilla">Montako pistettä korkeintaa riville</param>
        public static void TulostaPisteet(Vector[] pisteet, int maxRivilla)
        {
            // TODO: Tehtävä 1
            // Ota taulukosta pisteet kukin piste ja tulosta se näyttöön
            // Älä luo pisteitä, sillä ne on luotu ArvoPisteet (Tehtävä 2) funktiossa.
        }


        /// <summary>
        /// Arvotaan joukko 2D-pisteitä halutulle alueelle
        /// </summary>
        /// <param name="n">montako pistettä arvotaan</param>
        /// <param name="x1">alueen vasemman alakulman x</param>
        /// <param name="y1">alueen vasemman alakulman y</param>
        /// <param name="x2">alueen oikean yläkulman x</param>
        /// <param name="y2">alueen oikean yläkulman y</param>
        /// <returns></returns>
        public static Vector[] ArvoPisteet(int n, double x1, double y1, double x2, double y2)
        {
            // Tee n-kokoinen taulukko Vector-olioista.
            // Arvo kullekin alkiolle sattunnainen x ja y koordinaatti
            // parametrina tuleviin rajoihin käyttäen RandomGen-luokkaa
            // Poista alla oleva koodi joka tekee aina 4 samaa pistettä
            // TODO: Tehtävä 2
            Vector[] pisteet = new Vector[4];
            double x = RandomGen.NextDouble(0, 10);
            double y = RandomGen.NextDouble(0, 10);
            pisteet[0] = new Vector(x, y);
            pisteet[1] = new Vector(9, 2);
            pisteet[2] = new Vector(2, 9);
            pisteet[3] = new Vector(12, 5);
            return pisteet;
        }


        /// <summary>
        /// Etsitään pistettä lähimmän taulukon alkion indeksi.
        /// </summary>
        /// <param name="pisteet">taulukko jossa pisteet, joista lähintä etsitään</param>
        /// <param name="piste">piste johon muita verrataan</param>
        /// <returns>lähimmän pisteen indeksi, -1 jos taulukko tyhjä</returns>
        /// <example>
        /// // Kirjoita testejä...
        /// </example>
        public static int LahimmanIndeksi(Vector[] pisteet, Vector piste)
        {
            // Toteuta niin että palautetaan se indeksi, jossa on pistettä
            // lähimmän pisteen koordinaatti.  Tätä kutsutaan sitten kun toteutat
            // tehtävä 4:sta.
            // TODO: Tehtävä 3
            return -1;
        }


        /// <summary>
        /// Tulostetaan pistettä lähimmän pisteetn koordinaatti
        /// </summary>
        /// <param name="pisteet">taulukko, josta etsitään lähintä pistettä</param>
        /// <param name="piste">paikka jota lähin piste tulostetaan</param>
        public static void TulostaLahin(Vector[] pisteet, Vector piste)
        {
            // TODO: Tehtävä 4
            // etsi lähimmän pisteen indeksi ja siirrä
            // ja tulosta mikä koordinaatti löytyneessä indeksissä on
            // Älä luo uutta pistettä, koska merkkipiste on jo luotu Begin-metodissa.  Ainoastaan siirrä sen paikka.
        }
// BYCODEEND
    }
}

namespace MinJypeli
{
    /// <summary>
    /// Satunnaisgeneraattori. Luo satunnaisia arvoja, mm. lukuja, vektoreita sekä kulmia.
    /// </summary>
    public static class RandomGen
    {
        private static Random rand = new Random();

        /// <summary>
        /// Palauttaa satunnaisen liukuluvun parametrien <code>min</code> ja <code>max</code> väliltä.
        /// </summary>
        /// <param name="min">Pienin arvo jonka luku voi saada</param>
        /// <param name="max">Suurin arvo jonka luku voi saada</param>
        /// <returns>Satunnainen reaaliluku</returns>
        public static double NextDouble(double min, double max)
        {
            return min + rand.NextDouble() * (max - min);
        }


        /// <summary>
        /// Palauttaa satunnaisen vektorin.
        /// </summary>
        /// <param name="minX">Pienin sallittu X-koordinaatti</param>
        /// <param name="minY">Pienin sallittu Y-koordinaatti</param>
        /// <param name="maxX">Suurin sallittu X-koordinaatti</param>
        /// <param name="maxY">Suurin sallittu Y-koordinaatti</param>
        /// <returns>Satunnainen vektori</returns>
        public static Vector NextVector(double minX, double minY, double maxX, double maxY)
        {
            return new Vector(NextDouble(minX, maxX), NextDouble(minY, maxY));
        }
    }

    public struct Vector
    {
        /// <summary>
        /// Nollavektori.
        /// </summary>
        public static readonly Vector Zero = new Vector(0.0, 0.0);


        /// <summary>
        /// Etäisyys kahden pisteen välillä.
        /// </summary>
        public static double Distance(Vector p1, Vector p2)
        {
            double x, y;
            x = p1.X - p2.X;
            y = p1.Y - p2.Y;
            return Math.Sqrt((x * x + y * y));
        }

        public double X;
        public double Y;

        /// <summary>
        /// Vektorin pituus.
        /// </summary>
        public double Magnitude
        {
            get { return Math.Sqrt(MagnitudeSquared); }
        }

        /// <summary>
        /// Vektorin pituuden neliö.
        /// </summary>
        public double MagnitudeSquared
        {
            get { return X * X + Y * Y; }
        }

        /// <summary>
        /// Luo uuden vektorin komponenteista.
        /// </summary>
        /// <param name="X">X-komponentti</param>
        /// <param name="Y">Y-komponentti</param>
        public Vector(double X, double Y)
        {
            this.X = X;
            this.Y = Y;
        }


        /// <summary>
        /// Vektori merkkijonona, esim (2.3,4.1)
        /// </summary>
        /// <returns>lukupari merkkijonona</returns>
        public override string ToString()
        {
            return String.Format("({0:0.0},{1:0.0})", X, Y);
        }


        public static Vector Parse(string vectorStr)
        {
            if (vectorStr == null || vectorStr.Trim() == "") return new Vector(0, 0);

            string s = vectorStr.Replace("(", "").Replace(")", "").Replace(",", " ").Replace("  ", " ").Trim();
            string[] splitStr = s.Split(' ');

            if (splitStr.Length != 2)
                throw new FormatException("Not a vector string: " + vectorStr);

            double x = double.Parse(splitStr[0]);
            double y = double.Parse(splitStr[1]);

            return new Vector(x, y);
        }
    }
}

