using System;
using System.Collections.Generic;
using MinJypeli;

namespace Demo7
{
    /// @author  Vesa Lappalainen
    /// @author  Enni Stylman
    /// @version 29.10.2019
    /// <summary>
    /// Käsitellään pistejoukkoja
    /// </summary>
    public class Pisteet
    {
        private const double x1 = -5;
        private const double x2 = 20;
        private const double y1 = -5;
        private const double y2 = 20;


        /// <summary>
        /// Alustetaan pistetaulukko ja kysellään käyttäjältä pisteitä ja tulostetaan
        /// aina sitä lähimmän pisteen koordinaatit.
        /// Ohjelma loppuu kun käyttäjä vastaa pelkän return.
        /// </summary>
        public static void Main()
        {
            Vector[] pisteet;
            pisteet = ArvoPisteet(10, x1, y1, x2, y2);

            /*TulostaPisteet(pisteet, 5);

            while (true)
            {
                Console.Write("Anna pisteen koordinaatti muodossa (x,y) >");
                string s = Console.ReadLine();
                if (s == "") break;
                Vector piste = Vector.Parse(s);
                TulostaLahin(pisteet, piste);
            }
            */

            //Tehtävä E3

            Vector[] taulukko1;
            taulukko1 = ArvoPisteet(10, x1, y1, x2, y2);
            Vector[] taulukko2;
            taulukko2 = ArvoPisteet(20, x1, y1, x2, y2);

            Console.WriteLine("Tehtävä 3: Tulostellaan taulukosta pisteitä");
            Console.WriteLine("Ensin tulostetaan Taulukosta1");
            TulostaTaulukosta1(taulukko1);
            Console.WriteLine("Sitten tulostetaan Taulukosta2");
            TulostaTaulukosta2(taulukko2);
        }


        /// <summary>
        /// Tulostetaan pisteet muodossa (1,2) (9,2) (2,9) (12,5).
        /// Riville tulostuu korkeintaan maxRivilla pistettä sitten vaihdetaan riviä.
        /// </summary>
        /// <param name="pisteet">tulostettavien pisteiden koordinaatit</param>
        /// <param name="maxRivilla">Montako pistettä korkeintaa riville</param>
        public static void TulostaPisteet(Vector[] pisteet, int maxRivilla)
        {
            int rivilla = 0;
            foreach (Vector piste in pisteet)
            {
                Console.Write(piste + " ");
                rivilla++;
                if (rivilla % maxRivilla == 0) Console.WriteLine();
            }
        }


        /// <summary>
        /// Arvotaan joukko 2D-pisteitä halutulle alueelle
        /// </summary>
        /// <param name="n">montako pistettä arvotaan</param>
        /// <param name="x1">alueen vasemman alakulman x</param>
        /// <param name="y1">alueen vasemman alakulman y</param>
        /// <param name="x2">alueen oikean yläkulman x</param>
        /// <param name="y2">alueen oikean yläkulman y</param>
        /// <returns></returns>
        public static Vector[] ArvoPisteet(int n, double x1, double y1, double x2, double y2)
        {
            // Tee n-kokoinen taulukko Vector-olioista.
            // Arvo kullekin alkiolle sattunnainen x ja y koordinaatti
            // parametrina tuleviin rajoihin käyttäen RandomGen-luokkaa
            // Poista alla oleva koodi joka tekee aina 4 samaa pistettä
            // TODO: Tehtävä 2
            Vector[] pisteet = new Vector[n];
            for (int i = 0; i < pisteet.Length; i++)
            {
                double x = RandomGen.NextDouble(x1, x2);
                double y = RandomGen.NextDouble(y1, y2);
                pisteet[i] = new Vector(x, y);
            }
            return pisteet;
        }


        /// <summary>
        /// Etsitään pistettä lähimmän taulukon alkion indeksi.
        /// </summary>
        /// <param name="pisteet">taulukko jossa pisteet, joista lähintä etsitään</param>
        /// <param name="piste">piste johon muita verrataan</param>
        /// <returns>lähimmän pisteen indeksi, -1 jos taulukko tyhjä</returns>
        /// <example>
        /// <pre name="test">
        ///   Vector[] luvut = { new Vector(1,2),new Vector(3,4),new Vector(5,2),new Vector(5,5) };
        ///   LahimmanIndeksi(luvut,new Vector(3,5)) === 1;
        ///   LahimmanIndeksi(luvut,new Vector(0,0)) === 0;
        ///   LahimmanIndeksi(luvut,new Vector(5,3)) === 2;
        ///   LahimmanIndeksi(luvut,new Vector(15,5)) === 3;
        /// </pre>
        /// </example>
        public static int LahimmanIndeksi(Vector[] pisteet, Vector piste)
        {
            int paikka = -1;
            double pieninEtaisyys = double.MaxValue;
            for (int i = 0; i < pisteet.Length; i++)
            {
                Vector p = pisteet[i];
                double d = Vector.Distance(piste, p);
                if (d < pieninEtaisyys)
                {
                    paikka = i;
                    pieninEtaisyys = d;
                }
            }
            return paikka;
        }


        /// <summary>
        /// Tulostetaan pistettä lähimmän pisteetn koordinaatti
        /// </summary>
        /// <param name="pisteet">taulukko, josta etsitään lähintä pistettä</param>
        /// <param name="piste">paikka jota lähin piste tulostetaan</param>
        public static void TulostaLahin(Vector[] pisteet, Vector piste)
        {
            int i = LahimmanIndeksi(pisteet, piste);
            if (i < 0)
            {
                Console.WriteLine("Lähintä ei löydy");
                return;
            }
            Console.WriteLine("Lähin piste on " + pisteet[i]);
        }


        // BYCODEBEGIN

        //TEHTÄVÄ E3:
        //Tutki aliohjelmia TulostaTaulukosta1 ja TulostaTaulukosta2. 
        //Niissä on paljon toisteisuutta. Löydä aliohjelmien yhteiset piirteet ja laadi aliohjelma TulostaTaulukosta.
        //Muuta Tulostataulukosta1 ja TulostaTaulukosta2 -aliohjelmien toteutus yhden rivin mittaiseksi. 
        //Muista kirjoittaa myös kommentit ja testit.

        /*
        public static void TulostaTaulukosta(LISÄÄ PARAMETRIT)
        {
            Kirjoita toteutus
        }
        */

        /// <summary>
        /// Tulostetaan annetusta taulukosta pisteitä 4 riviä.
        /// </summary>
        /// <param name="pistetaulukko">tulostettavien pisteiden koordinaatteja taulukossa</param>
        public static void TulostaTaulukosta1(Vector[] pistetaulukko)
        {
            if (pistetaulukko.Length < 5) return;

            Console.WriteLine("Tässä tulostetaan pisteitä 5 kappaletta");
            for (int i = 0; i < 5; i++)
            {
                Console.WriteLine(pistetaulukko[i]);
            }
        }


        /// <summary>
        /// Tulostetaan annetusta taulukosta pisteitä 6 riviä.
        /// </summary>
        /// <param name="pistetaulukko">tulostettavien pisteiden koordinaatteja taulukossa</param>
        public static void TulostaTaulukosta2(Vector[] pistetaulukko2)
        {
            if (pistetaulukko2.Length < 7) return;
            Console.WriteLine("Tässä tulostetaan taulukosta pisteitä 3 kappaletta");
            for (int i = 0; i < 7; i++)
            {
                Console.WriteLine(pistetaulukko2[i]);
            }

        }
        // BYCODEEND
    }
}

namespace MinJypeli
{
    /// <summary>
    /// Satunnaisgeneraattori. Luo satunnaisia arvoja, mm. lukuja, vektoreita sekä kulmia.
    /// </summary>
    public static class RandomGen
    {
        private static Random rand = new Random();

        /// <summary>
        /// Palauttaa satunnaisen liukuluvun parametrien <code>min</code> ja <code>max</code> väliltä.
        /// </summary>
        /// <param name="min">Pienin arvo jonka luku voi saada</param>
        /// <param name="max">Suurin arvo jonka luku voi saada</param>
        /// <returns>Satunnainen reaaliluku</returns>
        public static double NextDouble(double min, double max)
        {
            return min + rand.NextDouble() * (max - min);
        }


        /// <summary>
        /// Palauttaa satunnaisen vektorin.
        /// </summary>
        /// <param name="minX">Pienin sallittu X-koordinaatti</param>
        /// <param name="minY">Pienin sallittu Y-koordinaatti</param>
        /// <param name="maxX">Suurin sallittu X-koordinaatti</param>
        /// <param name="maxY">Suurin sallittu Y-koordinaatti</param>
        /// <returns>Satunnainen vektori</returns>
        public static Vector NextVector(double minX, double minY, double maxX, double maxY)
        {
            return new Vector(NextDouble(minX, maxX), NextDouble(minY, maxY));
        }
    }

    public struct Vector
    {
        /// <summary>
        /// Nollavektori.
        /// </summary>
        public static readonly Vector Zero = new Vector(0.0, 0.0);


        /// <summary>
        /// Etäisyys kahden pisteen välillä.
        /// </summary>
        public static double Distance(Vector p1, Vector p2)
        {
            double x, y;
            x = p1.X - p2.X;
            y = p1.Y - p2.Y;
            return Math.Sqrt((x * x + y * y));
        }

        public double X;
        public double Y;

        /// <summary>
        /// Vektorin pituus.
        /// </summary>
        public double Magnitude
        {
            get { return Math.Sqrt(MagnitudeSquared); }
        }

        /// <summary>
        /// Vektorin pituuden neliö.
        /// </summary>
        public double MagnitudeSquared
        {
            get { return X * X + Y * Y; }
        }

        /// <summary>
        /// Luo uuden vektorin komponenteista.
        /// </summary>
        /// <param name="X">X-komponentti</param>
        /// <param name="Y">Y-komponentti</param>
        public Vector(double X, double Y)
        {
            this.X = X;
            this.Y = Y;
        }


        /// <summary>
        /// Vektori merkkijonona, esim (2.3,4.1)
        /// </summary>
        /// <returns>lukupari merkkijonona</returns>
        public override string ToString()
        {
            return String.Format("({0:0.0},{1:0.0})", X, Y);
        }


        public static Vector Parse(string vectorStr)
        {
            if (vectorStr == null || vectorStr.Trim() == "") return new Vector(0, 0);

            string s = vectorStr.Replace("(", "").Replace(")", "").Replace(",", " ").Replace("  ", " ").Trim();
            string[] splitStr = s.Split(' ');

            if (splitStr.Length != 2)
                throw new FormatException("Not a vector string: " + vectorStr);

            double x = double.Parse(splitStr[0]);
            double y = double.Parse(splitStr[1]);

            return new Vector(x, y);
        }
    }
}
