// Otetaan käyttöön Jyväskylän yliopiston Jypeli-kirjasto
using Jypeli;
using System;

/// @author  Vesa Lappalainen, Antti-Jussi Lakanen
/// @version 22.12.2011
///
///
/// <summary>
/// Luokka, jossa harjoitellaan piirtämistä lisäämällä ympyröitä ruudulle
/// </summary>
public class LumiukkoAli : PhysicsGame
{

    /// <summary>
    /// Piirretään oliot ja zoomataan kamera niin että kenttä näkyy kokonaan.
    /// </summary>
    public override void Begin()
    {
        Camera.ZoomToLevel();
        Level.Background.Color = Color.Black;

        PiirraLumiukko(this, -200, Level.Bottom + 200.0);
        PiirraLumiukko(this,  200, Level.Bottom + 200.0);
        PiirraLumiukko(this, -300, Level.Top - 200.0);
        PiirraLumiukko(this, 400, RandomGen.NextDouble(-500,500));
        // Gravity = new Vector(0, -200);
    }


    /// <summary>
    /// Aliohjelma piirtää lumiukon
    /// annettuun paikkaan.
    /// </summary>
    /// <param name="peli">Peli, johon lumiukko tehdään.</param>
    /// <param name="x">Lumiukon alimman pallon x-koordinaatti.</param>
    /// <param name="y">Lumiukon alimman pallon y-koordinaatti.</param>
    public static void PiirraLumiukko(PhysicsGame peli, double x, double y)
    {
        PhysicsObject p1 = new PhysicsObject(2 * 100.0, 2 * 100.0, Shape.Circle);
        p1.X = x;
        p1.Y = y;
        peli.Add(p1);

        PhysicsObject p2 = new PhysicsObject(2 * 50.0, 2 * 50.0, Shape.Circle);
        p2.X = x;
        p2.Y = p1.Y + 100 + 50;
        peli.Add(p2);

        PhysicsObject p3 = new PhysicsObject(2 * 30.0, 2 * 30.0, Shape.Circle);
        p3.X = x;
        p3.Y = p2.Y + 50 + 30;
        peli.Add(p3);

    }

}