using Jypeli;

/// @author  Vesa Lappalainen
/// @version 10.09.2011
///
/// <summary>
/// Ohjelma piirtää kuusi toisiaan sivuavaa palloa kolmion muotoon.
/// </summary>
public class Ympyrat2 : PhysicsGame
{
    /// <summary>
    /// Aliohjelma piirtää ruutuun yhden pallon, jonka
    /// säde on r, ja keskipiste on (x, y).
    /// </summary>
    /// <param name="peli">Peli, johon neliö piirretään</param>
    /// <param name="x">Pallon keskipisteen x-koordinaatti.</param>
    /// <param name="y">Pallon keskipisteen y-koordinaatti.</param>
    /// <param name="r">Pallon säde</param>
    /// <returns>lisätty pallo</returns>
    public static PhysicsObject PiirraPallo(Game peli, double x, double y, double r)
    {
        PhysicsObject pallo = new PhysicsObject(2 * r, 2 * r, Shape.Circle);
        pallo.Position = new Vector(x, y);  // tai pallo.X = x; pallo.Y = y;
        peli.Add(pallo);
        return pallo;
    }


    /// <summary>
    /// Luodaan pallot "pyramidiksi" antamalla niiden pudota toistensa päälle.
    /// </summary>
    public override void Begin()
    {
        Level.Background.Color = Color.Black;
        double r = 50;
        double y = Level.Bottom + r + 30;
        double h = 4 * r;
        PhysicsObject p1 = PiirraPallo(this, -2 * r, y, r);
        PhysicsObject p2 = PiirraPallo(this, 0, y, r);
        PhysicsObject p3 = PiirraPallo(this, 2 * r, y, r);
        p1.MakeStatic(); p2.MakeStatic(); p3.MakeStatic();
        y = y + h;
        PiirraPallo(this, -r, y, r);
        PiirraPallo(this, +r, y, r);
        y = y + h;
        PiirraPallo(this, 0, y, r);

        Gravity = new Vector(0, -100);
        Camera.ZoomToAllObjects(100);
    }
}
