using System;
using System.Text;

/// @author vesal
/// @version 18.9.2017
/// <summary>
/// Lasketaan malliksi laskuja
/// </summary>
public class Laskuja
{
    /// <summary>
    /// Lasketaan keskiarvo
    /// </summary>
    public static void Main()
    {
        int a = 10;
        int b = 6;
        double tulos = Keskiarvo(a, b);
        Console.WriteLine(tulos);

        a = 3;
        b = 2;
        tulos = Keskiarvo(a, b);  // (a + b) / 2.0;
        Console.WriteLine(tulos);


        double s = 1.5;
        double ala;

        ala = NelioAla(s);

        int luku1 = 5;
        int luku2 = 7;
        int ero;

        ero = Vahenna(luku1, luku2);
        Console.WriteLine(ero);

        int n = 4;
        char k = 'a';

        string jono;

        jono = Monista('s', 100, false);
        Console.WriteLine("Tuli: " + jono);

        int missa = EtsiPaikka("Mäyräkoira", 'k');
        Console.WriteLine(missa);

    }


    /// <summary>
    /// Etsitään mistä paikasta jonosta löytyy etsittävä kirjain
    /// </summary>
    /// <param name="jono">tutkittava jono</param>
    /// <param name="kirjain">etsittävä kirjain</param>
    /// <returns>paikka josta kirjain löytyy, -1 jos ei löydy</returns>
    /// <example>
    /// <pre name="test">
    ///   EtsiPaikka("Mäyräkoira", 'k') === 5;
    ///   EtsiPaikka("Mäyräkoira", 'M') === 0;
    ///   EtsiPaikka("Abba", 'M') === -1;
    /// </pre>
    /// </example>
    public static int EtsiPaikka(string jono, char kirjain)
    {
        int p = jono.IndexOf(kirjain);
        return p;
    }


    /// <summary>
    /// Monistetaan kirjainta tarvittava määrä.  Tarvittaessa muutetaan isoksi kirjaimeksi.
    /// </summary>
    /// <param name="k">monistetatva kirjain</param>
    /// <param name="n">montako monistetaan</param>
    /// <param name="isona">tuleeko isona vai pienenä</param>
    /// <returns>k monistettuna n kpl</returns>
    /// <example>
    /// <pre name="test">
    ///    Monista('a', 4, false) === "aaaa";
    ///    Monista('a', 4, true) === "AAAA";
    ///    Monista('A', 2, false) === "aa";
    ///    Monista('b', 0, false) === "";
    ///    Monista('b', -2, false) === "";
    /// </pre>
    /// </example>
    public static string Monista(char k, int n, bool isona)
    {
        StringBuilder tulos = new StringBuilder("");
        char kirjain = Char.ToLower(k);
        if (isona) kirjain = Char.ToUpper(k);
        for (int i = 0; i < n; i++)
            tulos.Append(kirjain);
        return tulos.ToString();
    }



    /// <summary>
    /// Lasketaan 2 luvun erotus
    /// </summary>
    /// <param name="a">luku josta vähennetään</param>
    /// <param name="b">luku joka vähennetään</param>
    /// <returns>a-b</returns>
    /// <example>
    /// <pre name="test">
    ///    Vahenna(2,2) === 0;
    ///    Vahenna(2,6) === -4;
    ///    Vahenna(7,5) === 2;
    /// </pre>
    /// </example>
    public static int Vahenna(int a, int b)
    {
        return a - b;
    }


    /// <summary>
    /// Lasketaan neliön ala
    /// </summary>
    /// <param name="s">sivun pituus</param>
    /// <returns>ala</returns>
    /// <example>
    /// <pre name="test">
    ///    NelioAla(1.0) ~~~ 1.0;
    ///    NelioAla(2.0) ~~~ 4.0;
    ///    NelioAla(1.5) ~~~ 2.25;
    /// </pre>
    /// </example>
    public static double NelioAla(double s)
    {
        double tulos;
        tulos = s * s;
        return tulos;
    }


    /// <summary>
    /// Palauttaa kahden luvun keskiarvon
    /// </summary>
    /// <param name="a">ensimmäinen luku</param>
    /// <param name="b">toinen luku</param>
    /// <returns>a:n ja b:n keskiarvon</returns>
    /// <example>
    /// <pre name="test">
    ///    Laskuja.Keskiarvo(0, 0) ~~~ 0;
    ///    Laskuja.Keskiarvo(6, 10) ~~~ 8;
    ///    Laskuja.Keskiarvo(2, 3) ~~~ 2.5;
    /// </pre>
    /// </example>
    public static double Keskiarvo(int a, int b) // esittelyrivi
    {
        double ka = (a + b) / 2.0;
        return ka;
    }

}