using System;
using System.Text;
using kokonaisluku = System.Int32;
/// @author  Vesa Lappalainen
/// @version 07.10.2012
/// <summary>
/// Esimerkkejä aliohjelminen kutsumisesta
/// </summary>
public class AliohjelmienKutsuminen
{
    /// <summary>
    /// Aliohjelmien kutsuesimerkkejä
    /// </summary>
    public static void Main()
    {
        Console.WriteLine(PoistaAlkuLisaaLoppuun(new StringBuilder("krokotiili"), 't', "talo"));
    }


    /// <summary>
    /// Etsii kirjaimen ja poistaa alun siihen asti ja lisää loppuun lisattavan jonon
    /// </summary>
    /// <param name="jono">muutettava jono</param>
    /// <param name="kirjain">etsittävä kirjain</param>
    /// <param name="lisattava">loppuun lisättävä jono</param>
    /// <example>
    /// <pre name="test">
    ///    StringBuilder jono = new StringBuilder("krokotiili");
    ///    PoistaAlkuLisaaLoppuun(jono,'t',"talo").ToString() === "tiilitalo";
    ///    PoistaAlkuLisaaLoppuun(jono,'r',"ko").ToString() === "tiilitaloko";
    ///    PoistaAlkuLisaaLoppuun(jono,'o',"").ToString() === "oko";
    ///    PoistaAlkuLisaaLoppuun(jono,'k',"").ToString() === "ko";
    ///    PoistaAlkuLisaaLoppuun(jono,'o',"").ToString() === "o";
    /// </pre>
    /// </example>
    // BYCODEBEGIN
    public static StringBuilder PoistaAlkuLisaaLoppuun(StringBuilder jono, char kirjain, string lisattava)
    {
        string s = jono.ToString();
        int i = s.IndexOf(kirjain);
        if (i >= 0) jono.Remove(0, i);
        jono.Remove(0, i).Append(lisattava);
        return jono;
    }
    // BYCODEEND
}

