using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;

/// @author  Vesa Lappalainen
/// @version 06.10.2020
/// <summary>
/// Luodaan monta palloa peliin
/// </summary>
public class MontaPalloa : PhysicsGame
{
    /// <summary>
    /// Luodaan pallot yms.
    /// </summary>
    public override void Begin()
    {
        Image[] kuvat = LoadImages("Baby", "Chell", "Cigur", "Igor", "Infant", "Jango", "Knive", "Leader", "Mum", "Ron", "Ven", "Yar");

        Level.Size = Screen.Size;
        Level.CreateBorders();
        // Level.Background.CreateGradient(Color.White, Color.Blue);
        Level.Background.Image = LoadImage("village");

        BoundingRectangle alue = Level.BoundingRect;


        for (int i = 0; i < 50; i++)
        {
            // LuoPallo(this, alue);
            PhysicsObject p = LuoPallo(this,alue);
            // p.Image = LoadImage("Baby");
            // p.Image = kuvat[1];
            int nr = RandomGen.NextInt(kuvat.Length);
            p.Image = kuvat[nr];
        }

    }


    /// <summary>
    /// Aliohjelma tekee 3-50 -säteisen pallon
    /// satunnaiseen paikkaan ruudulla.
    /// Pallo on myös satunnaisen värinen.
    /// </summary>
    /// <param name="peli">Mihin lisätään</param>
    /// <param name="alue">Alue josta x:n ja y:n arvonnan rajat</param>
    /// <returns>Luodun pallon viite</returns>
    public static PhysicsObject LuoPallo(GameObjectContainer peli, BoundingRectangle alue)
    {
        int sade = RandomGen.NextInt(3, 50);
        Vector paikka = RandomGen.NextVector(alue, sade);
        Color vari = RandomGen.NextColor();
        return LuoPallo(peli, paikka.X, paikka.Y, sade, vari);
    }


    /// <summary>
    /// Aliohjelma tekee ruudulle yhden pallon.
    /// </summary>
    /// <param name="peli">Mihin lisätään</param>
    /// <param name="x">Pallon x</param>
    /// <param name="y">Pallon y</param>
    /// <param name="sade">Pallon säde</param>
    /// <param name="vari">Pallon väri</param>
    /// <returns>Luodun pallon viite</returns>
    public static PhysicsObject LuoPallo(GameObjectContainer peli, double x, double y, double sade, Color vari)
    {
        PhysicsObject pallo = new PhysicsObject(sade * 2, sade * 2, Shape.Circle);
        pallo.X = x;
        pallo.Y = y;
        pallo.Color = vari;
        peli.Add(pallo);
        return pallo;
    }
}