using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// @author  Vesa Lappalainen
/// @version 07.10.2012
/// <summary>
/// Harjoitellaan taulukoiden käyttöä.
/// </summary>
public class Taulukoita
{
    /// <summary>
    /// Taulukkojen käyttöä
    /// </summary>
    /// <param name="args">ohjelmalle tuodut argumentit</param>
    public static void Main(string[] args)
    {
        int[] taulukko = new int[3];
        taulukko[0] = 1;
        taulukko[1] = 4;
        taulukko[2] = -1;
        int summa = Summa(taulukko);

        // indeksit           0   1   2   3   4   5   6   7   8   9  10  11
        int[] kkPituudet = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
        kkPituudet[1] = 29;

        Console.WriteLine(String.Join(" ", kkPituudet));

        summa = Summa(kkPituudet);
        Console.WriteLine(summa);
    }


    /// <summary>
    /// Aliohjelma palauttaa annetun
    /// kokonaislukutaulukon alkioiden
    /// summan.
    /// </summary>
    /// <param name="taulukko">Kokonaislukutaulukko</param>
    /// <returns>Taulukon alkioiden summa</returns>
    /// <example>
    /// <pre name="test">
    ///    int[] luvut = {1,2,3};
    ///    Summa(luvut) === 6;
    ///    luvut = new int[0];
    ///    Summa(luvut) === 0;
    ///    Summa(new int[]{-1,2}) === 1;
    /// </pre>
    /// </example>
    public static int Summa(int[] taulukko)
    {
        int summa = 0;
        int i = 0;
        while (i < taulukko.Length)
        {
            summa += taulukko[i];
            i++;
        }

        return summa;
    }

}

