using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// @author  Vesa Lappalainen
/// @version 07.10.2012
/// <summary>
/// Harjoitellaan taulukoiden käyttöä.
/// </summary>
public class Taulukoita2
{
    /// <summary>
    /// Taulukkojen käyttöä
    /// </summary>
    /// <param name="args">ohjelmalle tuodut argumentit</param>
    public static void Main()
    {
        int[] taulukko = new int[3];
        taulukko[0] = 1;
        taulukko[1] = 4;
        taulukko[2] = -1;

        // Taulukon voi määritellä ja alustaa yhdellä kertaa antamalla alkiot
        string[] mjtaulukko = { "Aku", "Hessu", "Minni" };
        TulostaTaulukko(mjtaulukko);

        //Console.WriteLine(mjtaulukko[0] + " " + mjtaulukko[1]);

        // indeksit           0   1   2   3   4   5   6   7   8   9  10  11
        int[] kkPituudet = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
        kkPituudet[1] = 29;

        TulostaTaulukko(kkPituudet);
        Console.WriteLine(String.Join(" ", kkPituudet));

        string kkPituudetJonona = TaulukkoJonoksi(kkPituudet, " ");
        Console.WriteLine(kkPituudetJonona);

        int summa = Summa(kkPituudet);
        Console.WriteLine(summa);

        TulostaLuvut(3, 8);

        // Console.WriteLine(args[0]);
    }


    /// <summary>
    /// Aliohjelma palauttaa annetun
    /// kokonaislukutaulukon alkioiden
    /// summan.
    /// </summary>
    /// <param name="taulukko">Kokonaislukutaulukko</param>
    /// <returns>Taulukon alkioiden summa</returns>
    /// <example>
    /// <pre name="test">
    ///    int[] luvut = {1,2,3};
    ///    Taulukoita.Summa(luvut) === 6;
    ///    luvut = new int[0];
    ///    Taulukoita.Summa(luvut) === 0;
    /// </pre>
    /// </example>
    public static int Summa(int[] taulukko)
    {
        int summa = 0;

        for (int i = 0; i < taulukko.Length; i++)
            summa += taulukko[i];
        //  summa = summa + taulukko[i]; // sama asia kuin yllä oleva

        return summa;
    }


    /// <summary>
    /// Lasketan taulukon alkioiden summa
    /// </summary>
    /// <param name="luvut">taulukko jonka summa lasketaan</param>
    /// <returns>lukujen summa</returns>
    /// <example>
    /// <pre name="test">
    ///   Taulukoita.SummaForeach(new int[]{1,2,3}) === 6;
    ///   Taulukoita.SummaForeach(new int[]{1,2}) === 3;
    ///   Taulukoita.SummaForeach(new int[]{1}) === 1;
    ///   Taulukoita.SummaForeach(new int[]{}) === 0;
    /// </pre>
    /// </example>
    public static int SummaForeach(int[] luvut)
    {
        int tulos = 0;
        foreach (int luku in luvut)
            tulos += luku;
        return tulos;
    }


    /// <summary>
    /// Aliohjelma tekee kokonaislukutaulukosta merkkijonon,
    /// missä yhdistetään kaikki taulukon alkiot. Alkioiden
    /// väliin tulee annettu erotinmerkki.
    /// </summary>
    /// <param name="taulukko">Kokonaislukutaulukko.</param>
    /// <param name="erotin">Erotinmerkki alkioiden väliin.</param>
    /// <returns>Merkkijono taulukon alkioista (ja erotinmerkeistä).</returns>
    /// <example>
    /// <pre name="test">
    ///   Taulukoita.TaulukkoJonoksi(new int[]{}," ") === "";
    ///   Taulukoita.TaulukkoJonoksi(new int[]{1,2,3}," ") === "1 2 3";
    ///   Taulukoita.TaulukkoJonoksi(new int[]{1,2,3}," / ") === "1 / 2 / 3";
    /// </pre>
    /// </example>
    public static string TaulukkoJonoksi(int[] taulukko, string erotin)
    {
        string eteen = "";
        StringBuilder jono = new StringBuilder("");

        for (int i = 0; i < taulukko.Length; i++)
        {
            jono.Append(eteen);
            jono.Append(taulukko[i]);
            eteen = erotin; // ei luoda uutta oliota
        }
        return jono.ToString(); // StringBuilder-olio stringiksi
    }


    /// <summary>
    /// Aliohjelma tulostaa annetun int-taulukon niin että jokaisen luvun viereen
    /// tulostetaan vastaava indeksi.
    /// </summary>
    /// <param name="taulukko">Tulostettava kokonaislukutaulukko</param>
    public static void TulostaTaulukko(int[] taulukko)
    {
        for (int i = 0; i < taulukko.Length; i++)
        {
            int luku = taulukko[i];
            // Console.WriteLine("{0,2}: {1,3}", i, luku);
            Console.WriteLine($"{i,2}: {luku,3}");
        }
    }


    /// <summary>
    /// Aliohjelma tulostaa annetun string-taulukon.
    /// </summary>
    /// <param name="taulukko">Merkkijonotaulukko.</param>
    public static void TulostaTaulukko(string[] taulukko)
    {
        // toistorakenteita ovat while, for ja do-while,
        // sekä foreach

        //for (int i = 0; i < taulukko.Length; i++)
        //{
        //    string jono = taulukko[i];
        //    Console.Write(jono + " ");
        //}

        //foreach (string jono in taulukko)
        //    Console.Write(jono + " ");

        //int i = 0;
        //while (i < taulukko.Length)
        //{
        //    string jono = taulukko[i];
        //    Console.Write(jono + " ");
        //    i++;
        //}

        int i = 0;
        do
        {
            string jono = taulukko[i];
            Console.Write(jono + " ");
            i++;
        } while (i < taulukko.Length);

        Console.WriteLine();
    }


    /// <summary>
    /// Palautetaan taulukko, jossa on juoksevat numerot [0 - n-1]
    /// </summary>
    /// <param name="n">Montako lukua taulukkoon halutaan</param>
    /// <returns>Juoksevat numerot 0,1,...,n-1</returns>
    /// <example>
    /// <pre name="test">
    ///  String.Join(",",Taulukoita.AnnaLuvut(0)) === "";
    ///  String.Join(",",Taulukoita.AnnaLuvut(1)) === "0";
    ///  String.Join(",",Taulukoita.AnnaLuvut(3)) === "0,1,2";
    /// </pre>
    /// </example>
    public static int[] AnnaLuvut(int n)
    {
        int[] tulos = new int[n];
        for (int i = 0; i < n; i++)
            tulos[i] = i;
        return tulos;
    }


    /// <summary>
    /// Palautetaan taulukko, jossa on juoksevat numerot [alku, alku+askel, alku+2*askel...]
    /// </summary>
    /// <param name="alku">Mistä luvusta aloitetaan</param>
    /// <param name="maara">Montako lukua taulukkoon halutaan</param>
    /// <param name="alku">Mistä luvusta aloitetaan</param>
    /// <returns>n lukua askeleen välein</returns>
    /// <example>
    /// <pre name="test">
    ///  String.Join(",",Taulukoita.AnnaLuvut(0,3,2)) === "0,2,4";
    ///  String.Join(",",Taulukoita.AnnaLuvut(1,2,3)) === "1,4";
    ///  String.Join(",",Taulukoita.AnnaLuvut(1,3,-3)) === "1,-2,-5";
    /// </pre>
    /// </example>
    public static int[] AnnaLuvut(int alku, int maara, int askel)
    {
        int[] tulos = new int[maara];
        int luku = alku;
        for (int i = 0; i < maara; i++)
        {
            tulos[i] = luku;
            luku += askel;
        }
        // for (int i = 0,luku=alku; i < maara; i++,luku+=askel) tulos[i] = luku;
        return tulos;
    }


    /// <summary>
    /// Tulostetaan juoksevat numerot alku-loppu
    /// </summary>
    /// <param name="alku">mikä luku ekana</param>
    /// <param name="loppu">mihin lopetetaan (tulostetaan myös)</param>
    public static void TulostaLuvut(int alku, int loppu)
    {
        for (int i = alku; i <= loppu; i++)
        {
            Console.WriteLine("i = {0}", i);
        }
    }
}

