using System;
using System.Text;

/// @author  Vesa Lappalainen
/// @version 22.10.2012
/// <summary>
/// Harjoitellaan merkkijonojen pilkkomista.
/// </summary>
public class MjPilkkominen
{
    /// <summary>
    /// Kysellaan kayttajalta merkkijonoja ja
    /// tehdaan niista taulukkoja, lasketaan lukuja
    /// yhteen ja tulostellaan.
    /// </summary>
    public static void Main()
    {
        char[] erottimet = new char[] { ' ', ';', ',' };
        Console.Write("Erotinmerkit ovat: ");
        foreach (char merkki in erottimet)
        {
            Console.Write($"'{merkki}' ");
        }
        Console.WriteLine();
        // Console.Write("Kirjoita jono jossa sanoja > ");
        string mj = "  Kissa  istuu;;puu  ";  // Console.ReadLine();
        mj = mj.Trim();
        Console.WriteLine(mj);
        string[] pilkottu = mj.Split(erottimet); // ,StringSplitOptions.RemoveEmptyEntries);

        int[] t1 = MerkkijonoLuvuiksi("1 2 3", new char[] { ' ' });
        string luvutPotkossa = String.Join(",", t1);
        Console.WriteLine(luvutPotkossa);
    }


    /// <summary>
    /// Aliohjelma muuttaa annetun merkkijonon kokonaislukutaulukoksi
    /// siten, etta eri luvut erotellaan annetun merkkitaulukon (erotinmerkkien)
    /// perusteella. Alkuperäisen syötteen alusta ja lopusta poistetaan välilyönnit.
    /// </summary>
    /// <param name="lukusyote">Muunnettava merkkijono</param>
    /// <param name="erottimet">Sallitut erotinmerkit merkkitaulukossa</param>
    /// <returns>Merkkijonosta selvitetty kokonaislukutaulukko. null jos yksikin luku väärin</returns>
    /// @example
    /// <pre name="test">
    /// int[] t1 = MerkkijonoLuvuiksi("1 2 3", new char[] {' '});
    /// String.Join(" ", t1) === "1 2 3";
    /// int[] t2 = MerkkijonoLuvuiksi(" ,,1;;3  ;5  ", new char[] {' ', ',', ';'});
    /// String.Join(" ", t2) === "0 0 1 0 3 0 0 5";
    /// int[] t3 = MerkkijonoLuvuiksi("1;;3  ;5", new char[] {' ', ',', ';'});
    /// String.Join(" ", t3) === "1 0 3 0 0 5";
    /// MerkkijonoLuvuiksi("1 3k 5", new char[] {' '}) === null;
    /// </pre>
    /// @endexample
    public static int[] MerkkijonoLuvuiksi(string lukusyote, char[] erottimet )
    {
        string[] pilkottu = lukusyote.Trim().Split(erottimet);
        int[] luvut = new int[pilkottu.Length];
        for (int i = 0; i < pilkottu.Length; i++)
        {
            string pala = pilkottu[i];
            if (!String.IsNullOrEmpty(pala))
                if (!int.TryParse(pala, out luvut[i])) return null;
        }
        return luvut;
    }



    /// <summary>
    /// Tulostetaan merkkijonotaulukon palat
    /// </summary>
    /// <param name="palat">Tulostettava merkkijonotaulukko</param>
    public static void TulostaPalat(string[] palat)
    { 
        foreach (string pala in palat)
            Console.WriteLine($"Pala: \"{pala}\"");
        Console.WriteLine("------------------------");
    }

}