using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/// @author Omanimi
/// @version Päivämäärä
/// <summary>
/// 
/// </summary>
public class Listat
{
    /// <summary>
    /// 
    /// </summary>
    public static void Main()
    {
        int[] taulukko = { 3, 5, 6, 99, 5, 5, 2, 23 };
        int tkoko = taulukko.Length;
        Console.WriteLine(String.Join(" ", taulukko) + " koko: " + tkoko);
        taulukko[1] = 9;
        int maara = LaskeAlkiot(taulukko, 5);
        Console.WriteLine(maara);

        List<int> lista = new List<int>();
        lista.Add(3); lista.Add(2); lista.Add(5);
        lista[1] = 9;
        lista.Add(99);
        lista.Insert(2, 55);

        int lkoko = lista.Count; // Huom!  Määrä eri tavalla
        Console.WriteLine(String.Join(" ", lista) + " koko: " + lkoko);
        lista.Remove(99);      // ja poistaa (ensimmäisen)
        Console.WriteLine(String.Join(" ", lista) + " koko: " + lista.Count + " " + lista.Capacity);

        int suurin = Suurin(lista);
        Console.WriteLine(suurin);

        List<string> slista = new List<string>() { "kissa", "täi", "koira", "mato", "kissa", "täi" };
        maara = LaskeAlkiot(slista, "täi");
        Console.WriteLine(maara);

        int summa = lista.Sum(Onko5);
        int lkm5 = lista.Sum(delegate (int a) { if (a == 5) return 1; return 0; });
        lkm5 = lista.Sum(a => a == 5 ? 1 : 0); // lambda lauseke

        int paikka5 = lista.IndexOf(5);
        IEnumerable<int> vitoset = lista.Where(a => a == 5);

        Console.WriteLine(summa);
    }


    public static int Onko5(int a)
    {
        if (a == 5) return 1;
        return 0;
    }



    /// <summary>
    /// Etsitään listan suurin
    /// </summary>
    /// <param name="luvut">lista josta suurinta etsitään</param>
    /// <returns>listan suurin tai 0 jos lista tyhjä</returns>
    /// <example>
    /// <pre name="test">
    ///    List<int>lista = new List<int>(){5,3,8,7});
    ///    Suurin(lista) === 8;
    ///    Suurin(new List<int>(){1,2,3}) === 3;
    ///    Suurin(new List<int>(){4,2,3}) === 4;
    ///    Suurin(new List<int>(){1,5,3}) === 5;
    ///    Suurin(new List<int>()) === 0;
    /// </pre>
    /// </example>
    public static int Suurin(List<int> luvut)
    {
        if (luvut.Count == 0) return 0;
        int suurin = luvut[0];
        foreach (int luku in luvut)
        {
            if (luku > suurin) suurin = luku;
        }
        return suurin;
    }


    public static int LaskeAlkiot<T>(IList<T> alkiot, T mitaEtsitaan)
    {
        int lkm = 0;
        foreach (T alkio in alkiot)
            if (alkio.Equals(mitaEtsitaan)) lkm++;
        return lkm;
    }
}
