using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


/// @author  Vesa Lappalainen
/// @version 27.10.2012
/// <summary>
/// Esimerkkejä olioista
/// </summary>
public class Elaimet
{
    /// <summary>
    /// Tutkitaan olioiden käyttäytymistä
    /// </summary>
    public static void Main()
    {
        Kissa miuku = new Kissa("Miuku", 900);
        Kissa mirri = new Kissa("Mirri", 19000);
        Koira musti = new Koira("Musti", 2700);

        miuku.Aantele();
        mirri.Aantele();
        musti.Aantele();

        Console.WriteLine(miuku); // kutsuu oikeasti miuku.ToString();
        Console.WriteLine(mirri); // kutsuu oikeasti mirri.ToString();
        Console.WriteLine(musti);

        List<Kissa> elaimet = new List<Kissa>();
        elaimet.Add(miuku);
        elaimet.Add(mirri);
        // elaimet.Add(musti); // Nyyh???

        foreach (Kissa elain in elaimet)
        {
            elain.Aantele();
            Console.WriteLine(elain);
        }


    }
}


public class Koira // Luokka
{
    private string nimi;
    private double paino;

    public Koira(string nimi, double paino)   // muodostaja
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    public void Aantele()
    {
        Console.WriteLine("Hau hau");
    }


    public override string ToString()
    {
        return nimi + " " + paino;
    }
}


public class Kissa // Luokka
{
    private string nimi;
    private double paino;

    public Kissa(string nimi, double paino)   // muodostaja
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    public void Aantele()
    {
        Console.WriteLine("Miuaa");
    }


    public override string ToString()
    {
        return nimi + " " + paino;
    }
}