using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


/// @author  Vesa Lappalainen
/// @version 27.10.2012
/// <summary>
/// Esimerkkejä olioista
/// </summary>
public class ElaimetPerimalla
{
    /// <summary>
    /// Tutkitaan olioiden käyttäytymistä
    /// </summary>
    public static void Main()
    {
        Kissa miuku = new Kissa("Miuku", 900);
        Kissa mirri = new Kissa("Mirri", 19000);
        Koira musti = new Koira("Musti", 2700, true);
        musti.Juoksuvauhti = 20;

        /*
        miuku.Aantele();
        mirri.Aantele();
        musti.Aantele();

        Console.WriteLine(miuku); // kutsuu oikeasti miuku.ToString();
        Console.WriteLine(mirri); // kutsuu oikeasti mirri.ToString();
        Console.WriteLine(musti);
        */

        List<Elain> elaimet = new List<Elain>();
        elaimet.Add(miuku);
        elaimet.Add(mirri);
        elaimet.Add(musti); // JIppii!!!

        foreach (Elain elain in elaimet)
        {
            elain.Aantele();
            Console.WriteLine(elain);
        }

        musti.Kuolaa = false;
        musti.Aantele();
    }
}


public class Elain // Luokka
{
    private string nimi;
    private double paino;

    public Elain(string nimi, double paino)   // muodostaja
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    public virtual void Aantele()
    {
        Console.WriteLine("???");
    }


    public override string ToString()
    {
        return nimi + " " + paino;
    }
}


public class Kissa: Elain // kissa on eläin  IS-A sääntö., vrt HAS-A sääntö
{
    private int hannanpituus;

    public Kissa(string nimi, double paino) : base(nimi, paino)
    {
        // ei tarvii tehdä mitään
        hannanpituus = 20;
    }


    public override void Aantele()
    {
        Console.WriteLine("Miuaa");
    }

    /// <summary>
    /// Kissan tiedot merkkijonona
    /// </summary>
    /// <returns>Kissan tiedot merkkijonona</returns>
    public override string ToString()
    {
        return base.ToString() + " " + hannanpituus;
    }
}


public class Koira : Elain
{
    private bool kuolaa = false;

    public bool Kuolaa
    {
        set { kuolaa = value; }   // pluto.Kuolaa = false;
        get { return kuolaa; }    // if ( pluto.Kuolaa ) ...
    }

    public double Juoksuvauhti { get; set; } // luo automaattisesti vastaavan attribuutin

    public Koira(string nimi, double paino, bool kuolaa = false) : base(nimi, paino)
    {
        this.kuolaa = kuolaa;
    }


    public override void Aantele()
    {
        Console.WriteLine("Hau hau");
        if (kuolaa) Console.WriteLine("lurps");
    }


    public override string ToString()
    {
        return base.ToString() + " " + kuolaa + " " + Juoksuvauhti;
    }
}


