using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;
using System;
using System.Collections.Generic;

public class Hirsipuu : PhysicsGame
{
    private static readonly string[] kirjaimet =
    {
        "QWERTYUIOPÅ",
        "ASDFGHJKLÖÄ",
        "ZXCVBNM -"
    };


    public override void Begin()
    {
        Level.Background.CreateGradient(Color.Brown, Color.Black);

        // Kirjain k = new Kirjain(this, 'A', new Vector(100, -100), new Vector(100,100));
        // Kirjain b = new Kirjain(this, 'B', new Vector(200, -100), new Vector(100, 100));
        Aakkoset aakkoset = new Aakkoset(this, kirjaimet, new Vector(-200, 0), 800);
        Sana sana = new Sana(this, new Vector(-200, 300), "LUMIUKKO", 100);
        Camera.Zoom(0.5);

        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }
}

public class Sana
{
    private string teksti;
    private Vector position;
    public Vector Position { get { return position; } }
    private List<Kirjain> kirjaimet = new List<Kirjain>();
    private PhysicsGame peli;

    public Sana(PhysicsGame peli, Vector p, string teksti, double d)
    {
        this.teksti = teksti;
        this.position = p;
        Vector sarakesiirtyma = new Vector(d * 1.1, 0);
        Vector paikka = p;
        this.peli = peli;
        Vector koko = new Vector(d, d);
        for (int sarake = 0; sarake < teksti.Length; sarake++)
        {
            char kirjain = teksti[sarake];
            Kirjain palikka = new Kirjain(peli, kirjain, paikka, koko, false);
            this.kirjaimet.Add(palikka);
            paikka += sarakesiirtyma;
        }
    }

}


public class Aakkoset
{
    public Aakkoset(PhysicsGame peli, string[] kirjaimet, Vector p, double w)
    {
        if (kirjaimet.Length == 0) return;
        int n = kirjaimet[0].Length; // TODO: etsi pisin rivi
        double d = w/n;
        Vector rivisiirtyma = new Vector(d*0.2, -d*1.1);
        Vector sarakesiirtyma = new Vector(d*1.1, 0);

        for (int rivi = 0; rivi < kirjaimet.Length; rivi++)
        {
            string jono = kirjaimet[rivi];
            Vector paikka = p + rivi * rivisiirtyma;
            for (int sarake = 0; sarake < jono.Length; sarake++)
            {
                char kirjain = jono[sarake];
                Kirjain k = new Kirjain(peli, kirjain, paikka, new Vector(d, d));
                paikka += sarakesiirtyma;
            }
        }
    }
}


public class Kirjain: PhysicsObject
{
    private static readonly Image image = Game.LoadImage("puupalikka");
    private static readonly Font fontti = new Font(70, true);

    public Kirjain(PhysicsGame peli, char k, Vector p, Vector koko, bool nakyy=true): base(koko.X, koko.Y)
    {
        Label label = new Label("" + k);
        this.Position = p;
        label.Position = this.Position;
        this.Add(label);
        label.IsVisible = nakyy;
        
        this.Image = image;
        
        label.Font = fontti;
        peli.Add(this);
    }
}
