using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

/// @author vesal
/// @version 2.11.2021
/// <summary>
/// <pre>
///  Aluksi ohjelma kysyy 
///     Anna tulos>?????
///     ja tulostaa sanat joissa noin monta merkkiä
///  kysyminen:   
///     Kysyy arvauksen ja tuloksen
///        Anna arvaamasi kirjain >A
///        Anna tulos >?A??A
///     Tulostaa ne sanat, jotka täsmää tuohon ehtoon   
///     (etsii yleisimmän kirjaimen ko sanoista ja ehottaa sitä)
///  jatketaan kysymyisestä   
/// </pre> 
/// </summary>
public class Hirsiapu
{
    /// <summary>
    /// Kysellään arvauksia ja tulostetaan mahdollisia sanoja
    /// </summary>
    public static void Main(string[] args)
    {
        string nimi = "sanat.txt";
        if (args.Length > 0) nimi = args[0];
        string[] sanat = File.ReadAllLines(nimi);
        StringBuilder kaytetyt = new StringBuilder();
        string piste = ".";
        string tulos = "";

        while (true)
        {
            Console.Write($"Anna hirsipuun tulos {tulos}>");
            string t = Console.ReadLine();
            if (t == null || t == "!") break;
            if (t != "") tulos = t;

            string maski = tulos.Replace("?", piste);
            Regex regex = new Regex("^" + maski + "$", RegexOptions.Compiled | RegexOptions.IgnoreCase);
            foreach (string rivi in sanat) // tutkitaan mitkä rivit täsmäävät
            {  // rivi AAKKONEN esim
                Match match = regex.Match(rivi);
                if (match.Success)
                {
                    Console.WriteLine(rivi);
                }
            }

            // tulosta jakauma kirjaimista  S: 30, P: 25, 

            Console.Write("Anna arvaamasi kirjain >");
            string kirjain = Console.ReadLine();
            if (kirjain == null || kirjain == "" || kirjain == "!") break;
            kirjain = kirjain.ToUpper();
            kaytetyt.Append(kirjain);
            piste = "[^" + kaytetyt.ToString() + "]"; // tulle esim [^AUO]

        }
    }

}
