public class Rekursio
{
    public static void Main()
    {
        long tulos = Kertoma(4);
        long tulosf = KertomaFor(4);
        System.Console.WriteLine(tulos);
        System.Console.WriteLine(tulos + " " + tulosf);
    }

    /// <summary>
    /// Lasketaan luvun n kertoma rekursiivisesti
    /// </summary>
    /// <param name="n"></param>
    /// <returns></returns>
    /// <example>
    /// <pre name="test">
    ///   KertomaFor(0) === 1L;
    ///   KertomaFor(1) === 1L;
    ///   KertomaFor(2) === 2L;
    ///   KertomaFor(4) === 24L;
    ///   KertomaFor(5) === 120L;
    ///   KertomaFor(6) === 720L;    
    /// </pre>
    /// </example>
    public static long KertomaFor(int n)
    {
        long tulos = 1;
        for (int i = 2; i <= n; i++)
            tulos = tulos * i;
        return tulos;
    }



    /// <summary>
    /// Lasketaan luvun n kertoma rekursiivisesti
    /// </summary>
    /// <param name="n"></param>
    /// <returns></returns>
    /// <example>
    /// <pre name="test">
    ///   Kertoma(0) === 1L;
    ///   Kertoma(1) === 1L;
    ///   Kertoma(2) === 2L;
    ///   Kertoma(4) === 24L;
    ///   Kertoma(5) === 120L;
    ///   Kertoma(6) === 720L;    
    /// </pre>
    /// </example>
    public static long Kertoma(int n)
    {
        if (n <= 1) return 1L;
        return n * Kertoma(n-1);
    }

}


