using System;

/// @author Vesa Lappalainen
/// @version 8.11.2011
/// <summary>
/// Tutkitaan poikkeuksia
/// </summary>
public class Poikkeus
{
    /// <summary>
    /// Esimerkkejä poikkeuksista
    /// </summary>
    public static void Main()
    {
        int[] luvut = { 2, 4, 1 };
        /*
        luvut = new int[3]; // täynnä 0:ia
        luvut[0] = 2;
        luvut[1] = 4;
        luvut[2] = 1;
        */

        int a1 = 3, a2 = 4, a3 = 0, a4 = 7;

        try
        {
            int s = Summa(luvut, 0, 4);
            Console.WriteLine(s);
            Console.WriteLine(10 / a1);
            Console.WriteLine(10 / a2);
            Console.WriteLine(10 / a3);
            Console.WriteLine(10 / a4);
        }
        catch (DivideByZeroException ex)
        {
            Console.WriteLine("Jaoit nollalla aasi! " + ex.Message);
        }

        catch (IndexOutOfRangeException ex)
        {
            Console.WriteLine(ex.Message);
        }

    }



    /// <summary>
    /// Lasketaan lukujen summa taulukon osajoukosta
    /// </summary>
    /// <param name="luvut">taulukko, jonka lukujen summa lasketaan</param>
    /// <param name="alku">indeksi josta summaaminen aloitetaan</param>
    /// <param name="loppu">loppuindeksi joka otetaan mukaan, -1 = taulukon loppuun</param>
    /// <returns>taulukon osajoukon summa</returns>
    /// @example
    /// <pre name="test">
    ///   int[] luvut = { 2, 4, 1 };
    ///   Summa(luvut) === 7;
    ///   Summa(luvut,0,2) === 7;
    ///   Summa(luvut,1,2) === 5;
    ///   Summa(luvut,1) === 5;
    ///   Summa(luvut,0,1) === 6;
    ///   Summa(luvut,1,1) === 4;
    ///   Summa(luvut,1,0) === 0; 
    ///   Summa(luvut,0,100) === 7;  #THROWS IndexOutOfRangeException
    ///   Summa(luvut,-4,100) === 7; #THROWS IndexOutOfRangeException
    /// </pre>
    /// @endexample
    public static int Summa(int[] luvut, int alku = 0, int loppu = -1)
    {
        int tulos = 0;
        if (loppu == -1) loppu = luvut.Length-1;
        // Seuraavat voisi olla oikeasti järkeviä, mutta tässä harjoitellaan
        // sitä, että poikkeus päästetään kutsuvaan ohjelmaan.
        // if (loppu >= luvut.Length) loppu = luvut.Length - 1;
        // if (alku < 0) alku = 0;
        for (int i = alku; i <= loppu; i++)
        {
            int luku = luvut[i];
            tulos += luku; // tulos = tulos + luku;
        }

        return tulos;
    }


}
