﻿using Jypeli;

/// @author  Vesa Lappalainen
/// @version 12.09.2011
///
/// <summary>
/// Ohjelma piirtää näyttöö kolmepalloisen lumiukon
/// </summary>
public class Lumiukko :  PhysicsGame
{
    /// <summary>
    /// Pääohjelmassa laitetaan "peli" käyntiin Jypelille tyypilliseen tapaan
    /// </summary>
    /// <param name="args">Ei käytössä</param>
    public static void Main(string[] args)
    {
        Lumiukko peli = new Lumiukko();
        peli.Run();
    }



    /// <summary>
    /// Aliohjelmassa piirretään ja zoomataan kamera siten että kenttä näkyy hyvin ruudulla.
    /// </summary>
    public override void Begin()
    {

       //Camera.ZoomTo(-1000,-1000,1000,1000);

       Level.BackgroundColor = Color.Black;
       Level.CreateBorders();

       PiirraLumiukko(this,0.0,Level.Bottom+200);
       PiirraLumiukko(this,200,Level.Bottom+400);
       PiirraLumiukko(this,-200,Level.Bottom+400);

       Gravity = new Vector(0, -400);
    }


    /// <summary>
    /// Aliohjelma piirtää lumiukon
    /// annettuun paikkaan.
    /// </summary>
    /// <param name="peli">Peli, johon lumiukko tehdään.</param>
    /// <param name="x">Lumiukon alimman pallon x-koordinaatti.</param>
    /// <param name="y">Lumiukon alimman pallon y-koordinaatti.</param>
    public static void PiirraLumiukko(PhysicsGame peli,double x,double y)
    {
       PhysicsObject p1,p2,p3;

       p1 = new PhysicsObject(2 * 100.0, 2 * 100.0, Shape.Circle);
       p1.X = x;
       p1.Y = y;
       peli.Add(p1);

       p2 = new PhysicsObject(2 * 50.0, 2 * 50.0, Shape.Circle);
       p2.Y = p1.Y + 100.0 + 50.0;
       p2.X = x;
       peli.Add(p2);
       p2.Color = Color.Red;

       p3 = new PhysicsObject(2 * 30.0, 2 * 30.0, Shape.Circle);
       p3.Y = p2.Y + 50.0 + 30.0;
       p3.X = x;
       peli.Add(p3);
    }




}