﻿using Jypeli;

/// @author  Vesa Lappalainen
/// @version 09.10.2011
///
/// <summary>
/// Kaksi lumiukkoa tyhmästi
/// </summary>
public class LumiukkoTyhma : PhysicsGame
{
    /// <summary>
    /// Pääohjelmassa laitetaan "peli" käyntiin Jypeli-kirjastolle tyypilliseen tapaan    
    /// </summary>
    /// <param name="args">Ei käytössä</param>
    public static void Main(string[] args)
    {
        using (LumiukkoTyhma peli = new LumiukkoTyhma())
        {
            peli.Run();
        }
    }

    /// <summary>
    /// Aliohjelmassa piirretään ja zoomataan kamera siten, että kenttä näkyy hyvin ruudulla.
    /// </summary>
    public override void Begin()
    {
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, Exit, "Lopeta peli");

        Camera.ZoomToLevel();
        Level.BackgroundColor = Color.Black;

        double x, y;
        PhysicsObject p1, p2, p3;

        // Tehdään ensimmäinen lumiukko
        x = 0; y = Level.Bottom + 200.0;

        p1 = new PhysicsObject(2 * 100.0, 2 * 100.0, Shape.Circle);
        p1.X = x;
        p1.Y = y;
        this.Add(p1);

        p2 = new PhysicsObject(2 * 50.0, 2 * 50.0, Shape.Circle);
        p2.X = x;
        p2.Y = p1.Y + 100 + 50;
        this.Add(p2);

        p3 = new PhysicsObject(2 * 30.0, 2 * 30.0, Shape.Circle);
        p3.X = x;
        p3.Y = p2.Y + 50 + 30;
        this.Add(p3);


        // Tehdään toinen lumiukko
        x = 200; y = Level.Bottom + 300.0;
        p1 = new PhysicsObject(2 * 100.0, 2 * 100.0, Shape.Circle);
        p1.X = x;
        p1.Y = y;
        this.Add(p1);

        p2 = new PhysicsObject(2 * 50.0, 2 * 50.0, Shape.Circle);
        p2.X = x;
        p2.Y = p1.Y + 100 + 50;
        this.Add(p2);

        p3 = new PhysicsObject(2 * 30.0, 2 * 30.0, Shape.Circle);
        p3.X = x;
        p3.Y = p2.Y + 50 + 30;
        this.Add(p3);
    }
}