﻿using System;

/// @author vesal
/// @version 18.9.2017
/// <summary>
/// Lasketaan malliksi laskuja
/// </summary>
public class Laskuja
{
    /// <summary>
    /// Lasketaan keskiarvo
    /// </summary>
    public static void Main()
    {
        int a = 10;
        int b = 6;
        double tulos = Keskiarvo(a, b);
        Console.WriteLine(tulos);

        a = 3;
        b = 2;
        tulos = Keskiarvo(a, b);  // (a + b) / 2.0;
        Console.WriteLine(tulos);

        double sivu = 1.5;
        double ala = NelionAla(sivu);
        Console.WriteLine(ala);
    }


    /// <summary>
    /// Palauttaa kahden luvun keskiarvon
    /// </summary>
    /// <param name="a">ensimmäinen luku</param>
    /// <param name="b">toinen luku</param>
    /// <returns>a:n ja b:n keskiarvon</returns>
    /// <example>
    /// <pre name="test">
    ///    Keskiarvo(0, 0) ~~~ 0;
    ///    Keskiarvo(6, 10) ~~~ 8;
    ///    Keskiarvo(2, 3) ~~~ 2.5;
    /// </pre>
    /// </example>
    public static double Keskiarvo(int a, int b) // esittelyrivi, header-row
    {
        double ka = (a + b) / 2.0;
        return ka;  // funktio palauttaa arvon
    }


    /// <summary>
    /// Lasketaan neliön pinta-ala
    /// </summary>
    /// <param name="s">Neliön sivun pituus</param>
    /// <returns>Neliön ala</returns>
    /// <example>
    /// <pre name="test">
    ///    NelionAla(0) ~~~ 0;
    ///    NelionAla(2) ~~~ 4;
    ///    NelionAla(1.5) ~~~ 2.25;
    /// </pre>
    /// </example>
    public static double NelionAla(double s)
    {
        return s * s;
    }
}