﻿using System;

/// @author Vesa Lappalainen
/// @version 25.9.2012
/// <summary>
/// Esimerkkejä funktioista ja muuttujista
/// </summary>
public class Funktioita
{
    /// <summary>
    /// Kutsutaan malliksi funktioita
    /// </summary>
    /// <param name="args">ei käytössä</param>
    public static void Main(string[] args)
    {
        double ala;

        ala = YmpyranAla(2);
        Console.WriteLine("Ympyrän ala on {0:0.00}", ala);

        ala = KolmionAla(3.0, 7.0);
        Console.WriteLine("Kolmion ala on " + ala);

        int a = 3, b = 4;
        double ka = Keskiarvo(a, b);
        Console.WriteLine("Keskiarvo on {0:0.000}", ka);
        ka = Keskiarvo(3, 5);
        Console.WriteLine("Keskiarvo on {0:0.000}", ka);
        Console.WriteLine("Keskiarvo on {0:0.000}", Keskiarvo(9, 7));
        Console.WriteLine("Keskiarvo on {0:0.000}", Keskiarvo(a, 6 + 2));
    }


    /// <summary>
    /// Kahden luvun keskiarvo
    /// </summary>
    /// <param name="a">1. luku</param>
    /// <param name="b">2. luku</param>
    /// <returns>lukujen keskiarvo</returns>
    /// <example>
    /// <pre name="test">
    ///  Funktioita.Keskiarvo(3,4) ~~~ 3.5;
    ///  Funktioita.Keskiarvo(1,1) ~~~ 1.0;
    ///  Funktioita.Keskiarvo(0,1) ~~~ 0.5;
    /// </pre>
    /// </example>
    public static double Keskiarvo(int a, int b)
    {
        int summa = a + b;
        double ka = summa / 2.0;
        return ka;
    }


    /// <summary>
    /// Lasketaan ympyrän pinta-ala
    /// </summary>
    /// <param name="r">ympyrän säde</param>
    /// <returns>ympyrän pinta-ala</returns>
    /// <example>
    /// <pre name="test">
    ///   Funktioita.YmpyranAla(1) ~~~ 3.1415926; 
    ///   Funktioita.YmpyranAla(2) ~~~ 12.5663706;
    /// </pre>
    /// </example>
    public static double YmpyranAla(double r)
    {
        return Math.PI * r * r;
    }


    /// <summary>
    /// Lasketaan kolmion pinta-ala
    /// </summary>
    /// <param name="kanta">kolmion kannan pituus</param>
    /// <param name="korkeus">kolmion korkeus</param>
    /// <returns>kolmion pinta-ala</returns>
    /// <example>
    /// <pre name="test">
    ///    Funktioita.KolmionAla(1,1) ~~~ 0.5;
    ///    Funktioita.KolmionAla(5,3) ~~~ 7.5;
    /// </pre>
    /// </example>
    public static double KolmionAla(double kanta, double korkeus)
    {
        double ala = kanta * korkeus / 2;
        return ala;
    }
}