﻿using System;
using System.Text;

/// @author vesal
/// @version 18.9.2017
/// <summary>
/// Lasketaan malliksi laskuja
/// </summary>
public class Laskuja
{
    /// <summary>
    /// Lasketaan keskiarvo
    /// </summary>
    public static void Main()
    {
        int a = 10;
        int b = 6;
        double tulos = Keskiarvo(a, b);
        Console.WriteLine(tulos);

        a = 3;
        b = 2;
        tulos = Keskiarvo(a, b);  // (a + b) / 2.0;
        Console.WriteLine(tulos);

        int ero;

        ero = Laskuja.Vahanna(a, b);
        Console.WriteLine(ero);

        char k = 'a';

        /*
        Console.Write("Anna sana>");
        string s = Console.ReadLine();
        k = s[0]; // tää ei ole hyvä koska kaatuu jos jono on tyhjä
        */

        int n = 4;
        bool tuleekoIso = false;
        string jono;

        jono = Monista(k, n, tuleekoIso);

        Console.WriteLine(jono);

        int missa = EtsiPaikka("Mäyräkoira", 'k');

        Console.WriteLine(missa);

    }


    /// <summary>
    /// Etsitään mistä paikasta jonosta löytyy etsittävä kirjain
    /// </summary>
    /// <param name="jono">tutkittava jono</param>
    /// <param name="kirjain">etsittävä kirjain</param>
    /// <returns>paikka josta kirjain löytyy, -1 jos ei löydy</returns>
    /// <example>
    /// <pre name="test">
    ///    Laskuja.EtsiPaikka("Mäyräkoira", 'k') === 5;
    ///    Laskuja.EtsiPaikka("Mäyräkoira", 'M') === 0;
    ///    Laskuja.EtsiPaikka("Abba", 'M') === -1;
    /// </pre>
    /// </example>
    public static int EtsiPaikka(string jono, char kirjain)
    {
        int p = jono.IndexOf(kirjain);
        return p;
    }


    /// <summary>
    /// Monistetaan kirjainta tarvittava määrä.  Tarvittaessa muutetaan isoksi kirjaimeksi.
    /// </summary>
    /// <param name="k">monistetatva kirjain</param>
    /// <param name="maara">montako monistetaan</param>
    /// <param name="isona">tuleeko isona vai pienenä</param>
    /// <returns>k monistettuna maara kpl</returns>
    /// <example>
    /// <pre name="test">
    ///    Laskuja.Monista('a', 4, false) === "aaaa";
    ///    Laskuja.Monista('a', 4, true) === "AAAA";
    ///    Laskuja.Monista('A', 2, false) === "aa";
    ///    Laskuja.Monista('b', 0, false) === "";
    ///    Laskuja.Monista('b', -2, false) === "";
    /// </pre>
    /// </example>
    public static string Monista(char k, int maara, bool isona)
    {
        StringBuilder tulos = new StringBuilder("");
        char kirjain = Char.ToLower(k);
        if (isona) kirjain = Char.ToUpper(k);
        for (int i = 0; i < maara; i++)
            tulos.Append(kirjain);
        return tulos.ToString();
    }


    /// <summary>
    /// Palautta kahden luvun erotuksne
    /// </summary>
    /// <param name="luku1">josta vähennetään</param>
    /// <param name="luku2">mitä vähennetään</param>
    /// <returns>luku1-luku2</returns>
    /// <example>
    /// <pre name="test">
    ///    Laskuja.Vahanna(0,0) === 0;
    ///    Laskuja.Vahanna(5,2) === 3;
    ///    Laskuja.Vahanna(5,-7) === 12;
    ///    Laskuja.Vahanna(5,7) === -2;
    /// </pre>
    /// </example>
    public static int Vahanna(int luku1, int luku2)
    {
        int tulos = luku1 - luku2;
        return tulos;
    }


    /// <summary>
    /// Palauttaa kahden luvun keskiarvon
    /// </summary>
    /// <param name="a">ensimmäinen luku</param>
    /// <param name="b">toinen luku</param>
    /// <returns>a:n ja b:n keskiarvon</returns>
    /// <example>
    /// <pre name="test">
    ///    Laskuja.Keskiarvo(0, 0) ~~~ 0;
    ///    Laskuja.Keskiarvo(6, 10) ~~~ 8;
    ///    Laskuja.Keskiarvo(2, 3) ~~~ 2.5;
    /// </pre>
    /// </example>
    public static double Keskiarvo(int a, int b) 
    {
        double ka = (a + b) / 2.0;
        return ka;
    }

}