﻿using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author vesal
/// @version 28.9.2015
/// <summary>
///  Lasketaan kolmion tietoja
/// </summary>
public class Kolmioita
{
    /// <summary>
    /// Testataan kolmion alan laskemista
    /// </summary>
    public static void Main()
    {
        double kanta1 = Kysy("Anna ekan kolmion kanta", 20);
        double korkeus1 = Kysy("Anna toisen kolmion kanta", 20); 
        double kanta2 = 5; 
        double korkeus2 = 6;


        double ala1 = KolmionAla(kanta1, korkeus1); //  kanta1 * korkeus1 * 1/2;  // a b 
        double ala2 = KolmionAla(kanta2, korkeus2);

        Console.WriteLine(ala1);
        Console.WriteLine(ala2);

        if (ala1 > ala2) Console.WriteLine("Eka voitti");
        else Console.WriteLine("toka voitti");

    }


    /// <summary>
    /// Laskee kolmion alan
    /// </summary>
    /// <param name="kanta">kolmion kanta</param>
    /// <param name="korkeus">kolmion korkeus</param>
    /// <returns>kolmion ala</returns>
    /// <example>
    /// <pre name="test">
    ///    KolmionAla(0,0) ~~~ 0;
    ///    KolmionAla(1,0) ~~~ 0;
    ///    KolmionAla(1,1) ~~~ 0.5;
    ///    KolmionAla(3,5) ~~~ 7.5;
    /// </pre>
    /// </example>
    public static double KolmionAla(double kanta, double korkeus)
    {
        return kanta * korkeus * 1 / 2;
    }


    /// <summary>
    /// Kysytään käyttäjältä kokonaisluku ja palautetaan se.
    /// Jos syöte ei ole kelvollinen, niin kysytään uudelleen.
    /// Jos käyttäjä painaa pelkän Return, palautetaan oletus
    /// </summary>
    /// <param name="kysymys">Kysymys joka näytetään käyttäjälle</param>
    /// <param name="oletus">arvo joka palautetaan jos annetaan pelkkä tyhjä</param>
    /// <returns>käyttäjän syöttämä luku</returns>
    public static int Kysy(string kysymys, int oletus)
    {
        while (true)
        {
            Console.Write("{0} ({1}) >", kysymys, oletus);
            string vastaus = Console.ReadLine();
            if (vastaus.Length == 0) return oletus;
            int tulos;
            if (int.TryParse(vastaus, out tulos)) return tulos;
            Console.WriteLine("Antamasi syöte '{0}' ei ole hyvä luku, anna uudelleen!", vastaus);
        }
    }
}
