﻿using System;

/// @author Vesa Lappalainen
/// @version 29.9.2012
/// <summary>
/// Funktioita merkkijojen käsittelyyn
/// </summary>
public class Jonoja
{
    /// <summary>
    /// Kutsutaan merkkijonofunktioita
    /// </summary>
    public static void Main()
    {
        string nimi = "Matti";
        Console.WriteLine(nimi);

        bool onko = OnkoT(nimi);
        if (onko) Console.WriteLine("oli T");

        onko = OnkoT("kissa");
        if (onko) Console.WriteLine("oli T");

        string alku = AnnaPuolet(nimi);
        Console.WriteLine("Alku oli " + alku);
    }


    /// <summary>
    /// Palautetaan merkkijonon alkupuolisko
    /// puolesta välistä katkaistuna
    /// </summary>
    /// <param name="jono">jono josta alkupuoli otetaan</param>
    /// <returns>jonon alkupuoli</returns>
    /// <example>
    /// <pre name="test">
    ///   Jonoja.AnnaPuolet("Matti") === "Ma";
    ///   Jonoja.AnnaPuolet("Masa") === "Ma";
    ///   Jonoja.AnnaPuolet("Osa") === "O";
    ///   Jonoja.AnnaPuolet("Ja") === "J";
    ///   Jonoja.AnnaPuolet("A") === "";
    ///   Jonoja.AnnaPuolet("") === "";
    /// </pre>
    /// </example>
    public static string AnnaPuolet(string jono)
    {
        int pituus = jono.Length;
        int paikka = pituus / 2;
        string alku = jono.Substring(0, paikka);
        return alku;
    }


    /// <summary>
    /// Tutkitaan onko jonossa t-kirjainta
    /// </summary>
    /// <param name="jono">Tutkittava jono</param>
    /// <returns>true jos on t, muuten false</returns>
    /// <example>
    /// <pre name="test">
    ///    Jonoja.OnkoT("kissa") === false;
    ///    Jonoja.OnkoT("tikka") === true;
    ///    Jonoja.OnkoT("Matti") === true;
    ///    Jonoja.OnkoT("ukot") === true;
    ///    Jonoja.OnkoT("Tikka") === false;
    /// </pre>
    /// </example>
    public static bool OnkoT(string jono)
    {
        int i = jono.IndexOf('t');
        if (i >= 0) return true;
        return false;
    }

}
