﻿using System;

/// @author Vesa Lappalainen
/// @version 27.09.2011
/// 
/// <summary>
/// Tutkitaan funktioita jotka palauttavat toisen luvuista
/// </summary>
public class Lukuja
{
    /// <summary>
    /// Tutkitaan kumpiko luvuista on toistaan suurempi
    /// </summary>
    public static void Main()
    {
        int a = 5;
        int b = 4;

        //double d = 1.234567;
        //Console.WriteLine("a={0:000} ja d={1:0.00}", a, b); // a=005 ja d=1.23
        //Console.WriteLine("a={0,5:000} ja d={1,10:0.00}", a, d);  // a=  005 ja d=      1.23
        //Console.WriteLine("a={0,-5:000} ja d={1,10:0.00}", a, d); // a=005   ja d=      1.23

        a = Kysy("Anna 1. luku", a);
        b = Kysy("Anna 2. luku", b);

        int iso = Suurempi(a, b);
        int pieni = Pienempi(a, b);

        Console.WriteLine("Suurempi oli: " + iso);
        Console.WriteLine("Pienempi oli: " + pieni);
    }


    /// <summary>
    /// Palauttaa suuremman arvon kahdesta kokonaisluvusta
    /// </summary>
    /// <param name="luku1">1. luku</param>
    /// <param name="luku2">2. luku</param>
    /// <returns>suuremaan luvun arvo</returns>
    /// <example>
    /// <pre name="test">
    ///  Suurempi(2,3) === 3;
    ///  Suurempi(4,1) === 4;
    ///  Suurempi(9,9) === 9;
    /// </pre>
    /// </example>
    public static int Suurempi(int luku1, int luku2)
    {
        if (luku2 > luku1) return luku2;

        return luku1;
    }


    /// <summary>
    /// Palauttaa pienemmän arvon kahdesta kokonaisluvusta
    /// </summary>
    /// <param name="luku1">1. luku</param>
    /// <param name="luku2">2. luku</param>
    /// <returns>suuremaan luvun arvo</returns>
    /// <example>
    /// <pre name="test">
    ///   Pienempi(2,3) === 2;
    ///   Pienempi(4,1) === 1;
    ///   Pienempi(9,9) === 9;
    /// </pre>
    /// </example>
    public static int Pienempi(int luku1, int luku2)
    {
        if (luku2 < luku1) return luku2;

        return luku1;
    }

    /// <summary>
    /// Kysytään käyttäjältä kokonaisluku ja palautetaan se.
    /// Jos syöte ei ole kelvollinen, niin kysytään uudelleen.
    /// Jos käyttäjä painaa pelkän Return, palautetaan oletus
    /// </summary>
    /// <param name="kysymys">Kysymys joka näytetään käyttäjälle</param>
    /// <param name="oletus">arvo joka palautetaan jos annetaan pelkkä tyhjä</param>
    /// <returns>käyttäjän syöttämä luku</returns>
    public static int Kysy(string kysymys, int oletus)
    {
        while (true)
        {
            Console.Write("{0} ({1}) >", kysymys, oletus);
            string vastaus = Console.ReadLine();
            if (vastaus == null || vastaus.Length == 0) return oletus;
            int tulos = 0;
            if (int.TryParse(vastaus, out tulos)) return tulos;
            Console.WriteLine("Antamasi syöte '{0}' ei ole hyvä luku, anna uudelleen!", vastaus);
        }
    }

}
