﻿using System;

/// @author  Vesa Lappalainen
/// @version 29.09.2012
///
/// <summary>
/// Tutkitaan mitä merkkijonoilla voi tehdä
/// </summary>
public class Merkkijonoja
{
    public static void Main()
    {
        // tyyppi muuttuja = arvo;
        int i = 5; 

        // luokka olio(viite)              olio
        string ekaJono = new String(new char[] { 'M', 'a', 't', 't', 'i' });

        string mj = "Matti";                // 01234
        Console.WriteLine(mj);              // Matti
        char eka = mj[0];
        Console.WriteLine(eka);             // M
        eka = 'A';
        Console.WriteLine((int)eka);        // 65
        eka++;
        Console.WriteLine(eka);             // B 
        eka = Char.ToLower(eka);
        Console.WriteLine(eka);             // b
        Console.WriteLine(eka - 1);         // 97
        Console.WriteLine(eka);             // b
        eka = (char)(eka - 1);
        Console.WriteLine(eka);             // a

        int montakoMerkkia = mj.Length;
        Console.WriteLine(montakoMerkkia);  // 5

        string mjPienena = mj.ToLower();
        Console.WriteLine(mjPienena);       // matti 

        string patka = mj.Substring(2);
        Console.WriteLine(patka);           // tti

        string patka2 = mj.Substring(1, 2); // String ja string samoja (jos on using System)
        Console.WriteLine(patka2);          // at

        string suku = "Meikäläinen";
        string nimi = mj + " " + suku;
        Console.WriteLine(nimi);            // Matti Meikäläinen

        Console.WriteLine(i + mj);          // 5Matti

        string stringLuku = "10";
        int luku = 4;

        Console.WriteLine("" + i + luku + " " + stringLuku + i); // 54 105
        Console.WriteLine("" + (i + luku) + " " + (stringLuku + i)); // 9 105
        int iLuku = int.Parse(stringLuku);
        Console.WriteLine("" + (iLuku + i)); // 15


        Console.Write("Anna jono >");
        string jono = Console.ReadLine();

        Console.WriteLine("Annoit siis: " + jono);

        string osa = AnnaMerkit(mj, 'a');
        Console.WriteLine(osa);
    }


    /// <summary>
    /// Funktio palauttaa merkkijonosta kaikki annettun merkin kohdalla
    /// olevan ja sen jälkeiset kirjaimet
    /// </summary>
    /// <param name="jono">mistä jonosta palautetaan</param>
    /// <param name="kirjain">minkä kirjaimen jälkeiset</param>
    /// <returns>jonon loppuosa</returns>
    /// <example>
    /// <pre name="test">
    ///    Merkkijonoja.AnnaMerkit("Matti", 'a') === "atti";
    ///    Merkkijonoja.AnnaMerkit("Matti", 'm') === "";
    ///    Merkkijonoja.AnnaMerkit("Matti", 'M') === "Matti";
    ///    Merkkijonoja.AnnaMerkit("Matti", 'i') === "i";
    /// </pre>
    /// </example>
    ///
    public static string AnnaMerkit(string jono, char kirjain)
    {
        int paikka = jono.IndexOf(kirjain);
        if (paikka < 0) return "";
        string uusi = jono.Substring(paikka, jono.Length - paikka);
        return uusi;
    }
}
