﻿using System.Text;
using kokonaisluku = System.Int32;

/// @author  Vesa Lappalainen
/// @version 07.10.2012
/// <summary>
/// Esimerkkejä aliohjelminen kutsumisesta
/// </summary>
public class AliohjelmienKutsuminen
{
    /// <summary>
    /// Aliohjelmien kutsuesimerkkejä
    /// </summary>
    public static void Main()
    {
        // https://docs.microsoft.com/en-us/dotnet/api/system.console.writeline?view=netcore-3.1#System_Console_WriteLine_System_String_
        // Namespace:  System
        // Console.WriteLine Method (String)
        // public static void WriteLine(string value)
        System.Console.WriteLine("Moikka!");
        kokonaisluku luku = 5;
        System.Console.WriteLine("Kokonaisluku = {0}", luku);

        char eka = 'A';

        // https://docs.microsoft.com/en-us/dotnet/api/system.char.tolower?view=netcore-3.1#System_Char_ToLower_System_Char_
        // Namespace:  System
        // Char.ToLower Method (Char)
        // public static char ToLower(char c)
        char pieni = System.Char.ToLower(eka);

        // https://docs.microsoft.com/en-us/dotnet/api/system.string.toupper?view=netcore-3.1#System_String_ToUpper
        // Namespace:  System
        // String.ToUpper Method 
        // public string ToUpper()
        string jono = "kalle";
        string isona = jono.ToUpper();

        // https://docs.microsoft.com/en-us/dotnet/api/system.math.sin?view=netcore-3.1#System_Math_Sin_System_Double_
        // Namespace:  System
        // Math.Sin Method 
        // public static double Sin(double a)
        double kulma = System.Math.PI / 4; // 45 astetta
        double y = System.Math.Sin(kulma);

        // https://docs.microsoft.com/en-us/dotnet/api/system.text.stringbuilder.-ctor?view=netcore-3.1#System_Text_StringBuilder__ctor_System_String_
        // Namespace: System.Text
        // StringBuilder.StringBuilder(String) Constructor
        // public StringBuilder (string value)
        StringBuilder sb = new StringBuilder("Krokotiili");

        // https://docs.microsoft.com/en-us/dotnet/api/system.text.stringbuilder.tostring?view=netcore-3.1
        // Namespace: System.Text
        // StringBuilder.ToString Method ()
        // public override string ToString()
        string s = sb.ToString();

        // https://docs.microsoft.com/en-us/dotnet/api/system.string.indexof?view=netcore-3.1#System_String_IndexOf_System_String_
        // Namespace:  System
        // String.IndexOf Method (Char)
        // public int IndexOf(char value)
        int i = s.IndexOf('t');

        // https://docs.microsoft.com/en-us/dotnet/api/system.text.stringbuilder.remove?view=netcore-3.1
        // Namespace: System.Text
        // StringBuilder.Remove Method 
        // public StringBuilder Remove(int startIndex,int length)
        sb.Remove(0, i);

        // https://docs.microsoft.com/en-us/dotnet/api/system.text.stringbuilder.append?view=netcore-3.1#System_Text_StringBuilder_Append_System_String_
        // Namespace:  System.Text
        // StringBuilder.Append Method (String)
        // public StringBuilder Append(string value)
        sb.Append("talo");

        System.Console.WriteLine(sb);

        StringBuilder sb2 = new StringBuilder("Krokotiili");
        System.Console.WriteLine(sb2.Remove(0, sb2.ToString().IndexOf('t')).Append("talo"));

        string s2 = "Krokotiili";
        int tp = s2.IndexOf('t');
        string s3 = s2.Substring(tp);
        string s4 = s3 + "talo";
        System.Console.WriteLine(s4);

        string s5 = "Krokotiili";
        System.Console.WriteLine(s5.Substring(s5.IndexOf('t')) + "talo");

        System.Console.WriteLine("Krokotiili".Substring("Krokotiili".IndexOf('t')) + "talo");

        StringBuilder sb3 = new StringBuilder("krokotiili");
        AliohjelmienKutsuminen.PoistaAlkuLisaaLoppuun(sb3, 't', "talo");
    }


    /// <summary>
    /// Etsii kirjaimen ja poistaa alun siihen asti ja lisää loppuun lisattavan jonon
    /// </summary>
    /// <param name="jono">muutettava jono</param>
    /// <param name="kirjain">etsittävä kirjain</param>
    /// <param name="lisattava">loppuun lisättävä jono</param>
    /// <example>
    /// <pre name="test">
    ///    StringBuilder jono = new StringBuilder("krokotiili");
    ///    PoistaAlkuLisaaLoppuun(jono,'t',"talo");
    ///    jono.ToString() === "tiilitalo";
    ///    PoistaAlkuLisaaLoppuun(jono,'r',"ko");
    ///    jono.ToString() === "tiilitaloko";
    ///    PoistaAlkuLisaaLoppuun(jono,'o',"");
    ///    jono.ToString() === "oko";
    ///    PoistaAlkuLisaaLoppuun(jono,'k',"");
    ///    jono.ToString() === "ko";
    ///    PoistaAlkuLisaaLoppuun(jono,'o',"");
    ///    jono.ToString() === "o";
    /// </pre>
    /// </example>
    public static void PoistaAlkuLisaaLoppuun(StringBuilder jono, char kirjain, string lisattava)
    {
        string s = jono.ToString();
        int i = s.IndexOf(kirjain);
        if (i >= 0) jono.Remove(0, i);
        jono.Append(lisattava);
    }
}
