using System.Text;
using BenchmarkDotNet.Attributes;
using BenchmarkDotNet.Running;

BenchmarkRunner.Run<SBBench>();

[MemoryDiagnoser]
public class SBBench
{
    private const int N = 10000;

    [Benchmark]
    public string SBTestAdd()
    {
        var sb = new StringBuilder("a");
        for (var i = 0; i < N; i++)
            sb.Append("a" + i);
        return sb.ToString();
    }

    [Benchmark]
    public string SBTestAppend()
    {
        var sb = new StringBuilder("a");
        for (var i = 0; i < N; i++)
        {
            sb.Append("a");
            sb.Append(i);
        }
        return sb.ToString();
    }

    [Benchmark]
    public string SBTestConcat()
    {
        var s = "";
        for (var i = 0; i < N; i++)
        {
            s += "a" + i;
        }
        return s;
    }

    [Benchmark]
    public string SBTestFormat()
    {
        var s = "";
        for (var i = 0; i < N; i++)
        {
            s += $"a{i}";
        }
        return s;
    }
}