﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

/// @author  Vesa Lappalainen
/// @version 06.10.2012
/// <summary>
/// Ohjelmassa vertaillaan String- ja StringBuilder-olioiden tehokkuutta.
/// </summary>
public class StringVsStringBuilder
{
    /// <summary>
    /// Otetaan aikaa merkkijonojen yhdistämsiestä
    /// </summary>
    /// <param name="args">ei käytössä</param>
    public static void Main(string[] args)
    {
        // Yhdistellään merkkijonoja StringBuilder-olion avulla
        const int MONTAKO = 50000; // Montako kertaa merkkijonoja yhdistellään
        Stopwatch sw = Stopwatch.StartNew();
        StringBuilder sb = new StringBuilder("a");
        for (int i = 0; i < MONTAKO; i++)
        {
            sb.Append("a");
            sb.Append(i);
        } // 10. kierroksen jälkeen aa0a1a2a3a4a5a6a7a8a9

        sw.Stop();
        double milliseconds = sw.Elapsed.TotalMilliseconds;
        System.Console.WriteLine("StringBuilder {0,7:##0.000} s", milliseconds / 1000);
        Console.WriteLine("Pituus " + sb.Length);
        sw.Reset();

        // StringBuilder insertillä sama juttu
        sw.Start();
        StringBuilder sb2 = new StringBuilder("a");
        for (int i = 0; i < MONTAKO; i++)
        {
            sb2.Insert(0, "a" + i);
        } // 2.kierroksen jälkeen "a1a0a" 4. kierroksen jälkeen a3a2a1a0a

        sw.Stop();
        milliseconds = sw.Elapsed.TotalMilliseconds;
        System.Console.WriteLine("SB Insert     {0,7:##0.000} s", milliseconds / 1000);
        Console.WriteLine("Pituus " + sb2.Length);

        sw.Reset();

        // Stringillä sama juttu
        sw.Start();
        string s = "a";
        for (int i = 0; i < MONTAKO; i++)
        {
            s += "a" + i;
        } // 2.kierroksen jälkeen "aa0a1" 4. aa0a1a2a3

        sw.Stop();
        milliseconds = sw.Elapsed.TotalMilliseconds;
        System.Console.WriteLine("String        {0,7:##0.000} s", milliseconds / 1000);
        Console.WriteLine("Pituus " + s.Length);
        Console.WriteLine(sb.ToString().Equals(s));

        // Tulostus 2013, Intel(R) Core(TM) i7-3770K CPU @ 3.50GHz
        // StringBuilder   0.014 s
        // Pituus 588891
        // String         16.703 s
        // Pituus 588891
        // True

    }
}
