﻿using System;

/// @author  Vesa Lappalainen
/// @version 12.10.2012
/// <summary>
/// Esimerkkjä aliohjelmien kutsumisesta
/// </summary>
public class Kutsuminen
{
    /// <summary>
    /// Kutsutaan aliohjelmia
    /// </summary>
    /// <param name="args">ei käytössä</param>
    public static void Main(string[] args)
    {
        int a = 4, b = 5;
        int iso;

        iso = Suurempi(a, b);
        Console.WriteLine(iso);

        iso = Suurempi(iso+1, 7 / 3 + 5 / 2);
        Console.WriteLine(iso);

        int[] luvut = new int[4];
        int[] m = luvut;

        luvut[2] = 4;
        luvut[1] = 6;
        m[3] = iso+3;

        VaihdaSuurin(luvut, 5);

        Console.WriteLine(String.Join(" ",luvut));
    }


    /// <summary>
    /// Palautetaan kahdesta luvusta suurempi
    /// </summary>
    /// <param name="luku1">eka luku</param>
    /// <param name="luku2">toinen luku</param>
    /// <returns>suurempi luvuista</returns>
    /// <example>
    /// <pre name="test">
    ///    Suurempi(3,4) === 4;
    ///    Suurempi(-3,4) === 4;
    ///    Suurempi(-3,-4) === -3;
    ///    Suurempi(2,2) === 2;
    /// </pre>
    /// </example>
    public static int Suurempi(int luku1, int luku2)
    {
        if (luku1 >= luku2) return luku1;
        return luku2;
    }


    /// <summary>
    /// Vaihdetaan taulukon suurin alkio halutuksi.
    /// </summary>
    /// <param name="t">taulukko josta suurinta etsitään ja missä suurin vaihdetaan</param>
    /// <param name="korvaavaArvo">suurimman alkion uusi arvo</param>
    /// <example>
    /// <pre name="test">
    ///   int[] luvut = {2,5,4,3};
    ///   VaihdaSuurin(luvut,1);
    ///   String.Join(" ",luvut) === "2 1 4 3";
    ///   VaihdaSuurin(luvut,1);
    ///   String.Join(" ",luvut) === "2 1 1 3";
    ///   VaihdaSuurin(luvut,9);
    ///   String.Join(" ",luvut) === "2 1 1 9";
    ///   VaihdaSuurin(luvut,1);
    ///   String.Join(" ",luvut) === "2 1 1 1";
    ///   VaihdaSuurin(luvut,-1);
    ///   String.Join(" ",luvut) === "-1 1 1 1";
    ///   luvut = new int[]{5};
    ///   VaihdaSuurin(luvut,2);
    ///   String.Join(" ",luvut) === "2";
    ///   luvut = new int[0];
    ///   VaihdaSuurin(luvut,2);
    ///   String.Join(" ",luvut) === "";
    /// </pre>
    /// </example>
    public static void VaihdaSuurin(int[] t, int korvaavaArvo)
    {
        int paikka = -1;
        int suurin = int.MinValue;
        for (int i = 0; i < t.Length; i++)
        {
            int luku = t[i];
            if (luku > suurin)
            {
                suurin = luku;
                paikka = i;
            }
        }

        if (paikka < 0) return;
        t[paikka] = korvaavaArvo;
    }

}
