﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


/// @author  Vesa Lappalainen
/// @version 27.10.2012   
/// <summary>
/// Esimerkkejä olioista
/// </summary>
public class Elaimet
{
    /// <summary>
    /// Tutkitaan olioiden käyttäytymistä
    /// </summary>
    public static void Main()
    {
        Kissa miuku = new Kissa("Miuku", 900);
        Kissa mirri = new Kissa("Mirri", 19000); 
        Koira musti = new Koira("Musti", 2700);

        miuku.Aantele();
        mirri.Aantele();
        musti.Aantele();
        Console.WriteLine(miuku); // kutsuu oikeasti miuku.ToString();
        Console.WriteLine(musti);

        List<Kissa> elaimet = new List<Kissa>();
        Kissa[] kissat = { miuku, mirri };
        elaimet.Add(miuku);
        elaimet.Add(mirri);

        foreach (Kissa elain in elaimet)
            elain.Aantele();

        List<Kissa> elaimet2 = new List<Kissa>{ miuku, mirri };
    }
}


/// <summary>
/// Kissa-luokka, joka osaa äännellä
/// </summary>
public class Kissa
{
    private string nimi;   // attribuutti
    private double paino;

    /// <summary>
    /// Alustetaan kissan nimi ja paino
    /// </summary>
    /// <param name="nimi">kissalle annettava nimi</param>
    /// <param name="paino">kissan alkuperäinen paino</param>
    public Kissa(string nimi, double paino) // muodostaja
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    /// <summary>
    /// Ääntelee kuten kissa ääntelee
    /// </summary>
    public void Aantele() // metodi
    {
        Console.WriteLine("Miuaa");
    }


    /// <summary>
    /// Kissan tiedot merkkijonona
    /// </summary>
    /// <returns>Kissan tiedot merkkijonona</returns>
    public override string ToString()
    {
        return nimi + " " + paino;
    }

}

/// <summary>
/// Koira-luokka, joka osaa äännellä
/// </summary>
public class Koira
{
    private string nimi;   // attribuutti
    private double paino;

    /// <summary>
    /// Alustetaan koiran nimi ja paino
    /// </summary>
    /// <param name="nimi">koiralle annettava nimi</param>
    /// <param name="paino">koiran alkupeärinen paino</param>
    public Koira(string nimi, double paino) // muodostaja
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    /// <summary>
    /// Ääntelee kuten koira ääntelee
    /// </summary>
    public void Aantele() // metodi
    {
        Console.WriteLine("Hau hau");
    }


    /// <summary>
    /// Koiran tiedot merkkijonona
    /// </summary>
    /// <returns>Koiran tiedot merkkijonona</returns>
    public override string ToString()
    {
        return nimi + " " + paino;
    }
}
