using Jypeli;
using FSJoint = FarseerPhysics.Dynamics.Joints.DistanceJoint;
using FarseerPhysics.Factories;
using FarseerPhysics.Dynamics;
using Jypeli.Farseer;

public class Liitos : PhysicsGame
{

    
    public class AxleJoint : Jypeli.AxleJoint
    {
        
        internal FSJoint InnerJoint
        {
            get
            {
                return (FSJoint)innerJoint;
            }
            set
            {
                innerJoint = value;
            }

        }


        /// <summary>
        /// Tällä voi säätää näytetäänkö liitospisteet
        /// </summary>
        public static bool DrawJointPoints { set; get; }


        /// <summary>
        /// Luo uuden akseliliitoksen kahden olion välille.
        /// </summary>
        /// <param name="firstObject">Ensimmäinen olio</param>
        /// <param name="secondObject">Toinen olio</param>
        /// <param name="axlePosition">Liitoksen akselin paikka</param>
        public AxleJoint(PhysicsObject firstObject, PhysicsObject secondObject, Vector axlePosition, Vector axlePosition2)
            : base(firstObject, secondObject, axlePosition)
        {
            World world = PhysicsGame.Instance.Engine as World;
            var first = firstObject.Body as PhysicsBody;
            var second = secondObject.Body as PhysicsBody;
            var ap2 = firstObject.Position + axlePosition;
            secondObject.Position = ap2 - axlePosition2;
            InnerJoint = JointFactory.CreateDistanceJoint(world,
                first.FSBody, second.FSBody,
                axlePosition * FSConvert.DisplayToSim, axlePosition2 * FSConvert.DisplayToSim);
                // axlePosition2 * FSConvert.DisplayToSim);
            InnerJoint.DampingRatio = 0.5f;
            InnerJoint.Frequency = 50;
            if (!DrawJointPoints) return;

            var dot = new GameObject(15, 15, Shape.Circle);
            dot.Color = Color.Red;
            dot.Position = firstObject.Position + axlePosition;
            firstObject.Add(dot);
            dot = new GameObject(10, 10, Shape.Circle);
            dot.Color = Color.Green;
            dot.Position = secondObject.Position + axlePosition2;
            secondObject.Add(dot);
            //InnerJoint.Enabled = false;
        }

    }
    

    public override void Begin()
    {
        AxleJoint.DrawJointPoints = true;
        double w = 100;
        double h = 20; 

        Level.Background.Color = Color.Black;
        var osa1 = new PhysicsObject(w, h);
        osa1.Position = new Vector(-w, 300);
        osa1.MakeStatic();
        // osa1.AddCollisionIgnoreGroup(1);
        Add(osa1);

        var osa = osa1;

        for (int i = 0; i < 7; i++)
        {
            var osa2 = new PhysicsObject(w, h);
            // osa2.AddCollisionIgnoreGroup(1);
            Add(osa2);
            var liitos = new AxleJoint(osa, osa2, new Vector(osa.Width / 2, 0), new Vector(-osa2.Width / 2, 0));
            // liitos.Softness = 0;
            Add(liitos);
            osa = osa2;
        }  

        Gravity = new Vector(0, -400);
    }
}

