using System;
using System.Text;
using System.Collections.Generic;
/**
 * Ohjelmalla siirretään merkkijonosta valitut merkit
 * toiseen merkkijonoon.
 * @author vesal
 * @version 11.11.2008
 * <pre>
 * ---------------------------------------------------------------------------
 * Syntaksi kysymyksille:
 * ---------------------------------------------------------------------------
 *  -- nro)     aloittaa uuden kysymyksen
 *              samalle tasolle sisennetyt ovat kysymystä
 *  vaihtoehto    sisennetty on vaihtoehto
 *  |aika|min|max|tyyppi|järjestetty|kombinaatio;pisteet;;kombinaatio;;pisteet...
 *                vaihtoehdot loppuvat tyhjään riviin tai | alkavaan riviin
 *                |-merkillä alkava rivi kertoo kysymyksen optiot
 *  aika        kysymyksen kestoaika
 *  min         minimimäärä vastauksia
 *  max         maksimimäärä vastauksia
 *  tyyppi      ???
 *  järjestetty kysymyksen vaihtohejoten antojärjestys merkitsee
 *  kombinaatio pisteitä tuottava vastauskombinaatio
 *  pisteet     kombinaatiosta saatava pistemärä
 * 
 *  |-rivin tai tyhjän rivin jälkeiset rivit ovat kommentteja
 * 
 * 
 * ---------------------------------------------------------------------------
 * Kysymykset:
 * ---------------------------------------------------------------------------
 *   Aluksi pääohjelma jossa on pelkkiä Stringejä
 * 
 *    public static void Main(string[] args) {
 *        string jono = "Mieleni minun tekevi, aivoni ajattelevi";
 *        string vokaalit = "aeiouyåäö";
 *        int maara = 3;
 * 
 *        string jonon3EnsimmaistaVokaalia = SiirraKirjaimet(jono,vokaalit,maara);
 * 
 *          Console.WriteLine("Jono:  " + jono); // Mlni minun tekevi, aivoni ajattelevi
 *          Console.WriteLine("3 vok: " + jonon3EnsimmaistaVokaalia); // iee
 * 
 *-- 1) Ihan aluksi tehdään
 *        en tiedä
 *        aletaan kirjoittamaan silmukoita
 *        mietitään ja kokeillaan miten itse tehtäisiin sama asia
 *        katsotaan Googlesta apua
 *        |30|1|1|0|0|3;1
 *
 *-- 2) Voiko toimia näillä muuttujien tyypeillä (yksi).
 *        en tiedä
 *        ei
 *        kyllä
 *        jos aliohjelma tehdään taitavasti
 *        |30|1|1|0|0|2;1
 *
 *-- 3) Miksi (monta)?
 *        en tiedä
 *        funktio voi palauttaa vain yhden arvon
 *        string luokan oliota ei voi muuttaa
 *        numero 3 ei ole string
 *        jonon3EnsimmaistaVokaalia on laiton muuttujan nimi
 *        |30|1|5|0|0|3;1
 *
 *-- 4) Minkä muuttujien tyyppi pitää vaihtaa (monta)?
 *        en tiedä
 *        jono
 *        jonon3EnsimmaistaVokaalia
 *        maara
 *        vokaalit
 *        |30|1|5|0|0|2;1
 *
 *-- 5) Mikä on oikea tyyppi muuttujalle jono (yksi)?
 *        string
 *        double
 *        int
 *        char
 *        StringBuilder
 *        int[]
 *        string[]
 *        void
 *        bool
 *        |20|1|1|0|0|5;1 
 *
 *   Vaihda string => StringBuilder  ja new StringBuilder("Mieleni minun tekevi, aivoni ajattelevi"); q4
 *
 *   Kirjoita pääohjelman yläpuolelle q5
 *     x1 x2 TYYPPI SiirraKirjaimet(...) {
 *
 *-- 6) Mitkä sanat x1 ja x2
 *      x1 x2 TYYPPI SiirraKirjaimet()
 *        static
 *        int
 *        public
 *        private
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        |30|1|8|0|1|31;1
 *
 *  Muuta public static TYYPPI SiirraKirjaimet()
 *
 *-- 8) Mikä on funktion palauttama tyyppi
 *      public static TYYPPI SiirraKirjaimet()
 *        ei mitään
 *        static
 *        int
 *        public
 *        private
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        |30|1|1|0|0|6;1
 *
 *   Kysy seuraavaksi tyypit yksi kerrallaan
 *
 *-- 9) Mikä on 1. parametrin tyyppi
 *        ei mitään
 *        int
 *        char
 *        private
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        |30|1|1|0|0|8;1
 *
 *-- 10) Mikä on 2. parametrin tyyppi
 *        ei mitään
 *        int
 *        char
 *        private
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        |30|1|1|0|0|5;1
 *
 *-- 11) Mikä on hyvä nimi parametrille 2
 *        vokaalit
 *        poistettava
 *        poistettavaMerkki
 *        siirrettavat
 *        vokaali
 *        |30|1|1|0|0|4;1
 *
 *-- 12) Mikä on 3. parametrin tyyppi
 *        ei mitään
 *        int
 *        char
 *        private
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        |30|1|1|0|0|2;1
 *
 *-- 13) Valitse 3 tärkeää asiaa JULKISESTI kommentoitavaksi
 *        käytetty algoritmi
 *        mitä funktio/aliohjelma tekee
 *        parametrien käyttötarkoitus
 *        käyttöesimerkit
 *        aliohjelman versionumero
 *        |60|3|3|0|0|234;1
 *
 *  Kirjoita kommentit q11
        /// Poistetaan jonosta korkeintaan maara kappaletta joukon siirrettavat kirjaimia.
        /// </summary>
        /// <param name="jono">mistä poistetaan</param>         
        /// <param name="siirrettavat">mitä kirjaimia poistetaan</param> 
        /// <param name="maara">montako korkeintaan poistetaan</param> 
        /// <returns>siirretyt merkit</returns> 
 *
 *-- 14) Mitä aliohjelmaan kirjoitetaan seuraavaksi testilähtöisessä kehityksessä (yksi)
 *        for (int i=0; i<jono.Length; i++) ...
 *        while (i<jono.Length ) ...
 *        if ( jono.Length == 0 ) ...
 *        return "";
 *        try ... catch ...
 *        for (int i=0; i<siirrettavat.Length; i++) ...
 *        |30|1|1|0|0|4;1
 *
 *    Lisää return "";
 *
 *-- 15) Mitä kirjoitetaan testilähtöisessä kehityksessä seuraavaksi (yksi)
 *        aliohjelman tarvitsemat silmukat
 *        aliohjelman parametrien alustus
 *        if ( jono.Length == 0 ) ...
 *        riittävän kattavat testit
 *        if ( siirrettavat.Length == 0 ) ...
 *        |30|1|1|0|0|4;1
 *
 * Lisää tyhjä comtest komentti
 *
 *-- 16) Mitkä seuraavista asioista olisi hyvä testata (monta)
 *        jonosta ei poistu mitään
 *        siirrettavat joukko on tyhjä
 *        jonossa on enemmän poistettavia kuin maaran verran
 *        jonossa on vähemmän poistettavia kuin määrän verran
 *        jonosta poistetaan k-kirjain
 *        jono menee tyhjäksi asti
 *        yritetään poistaa tyhjästä jonosta
 *        poistetaan kaikki välilyönnit
 *        |90|1|8|0|0|123467;1
 *
 *   Kirjoita testit: q14
        ///   StringBuilder jono = new StringBuilder("kissa istuu");
        ///   SiirraKirjaimet(jono,"",1)    === "";    jono.ToString() === "kissa istuu";
        ///   SiirraKirjaimet(jono,"xyz",1) === "";    jono.ToString() === "kissa istuu";
        ///   SiirraKirjaimet(jono,"aus",0) === "";    jono.ToString() === "kissa istuu";
        ///   SiirraKirjaimet(jono,"i",1)   === "i";   jono.ToString() === "kssa istuu";
        ///   SiirraKirjaimet(jono,"s",2)   === "ss";  jono.ToString() === "ka istuu";
        ///   SiirraKirjaimet(jono,"aus",3) === "asu"; jono.ToString() === "k itu";
        ///   SiirraKirjaimet(jono,"iu",3)  === "iu";  jono.ToString() === "k t";
        ///   SiirraKirjaimet(jono," ",1)   === " ";   jono.ToString() === "kt";
        ///   SiirraKirjaimet(jono,"kt",5)  === "kt";  jono.ToString() === "";
        ///   SiirraKirjaimet(jono,"kt",5)  === "";    jono.ToString() === "";
 *
 *
 *-- 17) Seuraavaksi tehdään
 *        ruvetaan miettimään silmukoita
 *        mietitään miten jonosta saadaan merkki pois
 *        ajetaan testit ja katsotaan että tulee punaista
 *        ruvetaan lukemaan tiedostoa
 *        |25|1|1|0|0|3;1
 *  
 *-- 18) Seuraavaksi pitäisi miettiä (yksi)
 *        millä silmukalla on paras mennä jono lävitse
 *        millä silmukalla on paras mennä merkit-joukko lävitse
 *        millaisella algoritmillä ongelma ratkaistaan
 *        montako vokaalia on suomenkielessä
 *        pitääkö lähteä syömään
 *        |40|1|1|0|0|3;1
 *
 *-- 19) Mikä algoritmeista toimisi riittävän monesti suoritettuna (ja tuottaisi testien tuloksen)  (yksi):
 *        otetaan seuraava siirrettavat-joukon kirjain ja poistetaan jonosta kaikki vastaavat
 *        kaksi sisäkkäistä silmukaa
 *        otetaan seuraava jonon kirjain ja jos se on siirrettavat joukossa, niin poistetaan kirjain jonosta
 *        lasketaan montako samaa kirjainta on kummassakin jonossa
 *        |40|1|1|0|0|3;1
 *
 *  Piirrä mitä tarkoittaa jono ja siitä kirjaimen poistaminen, erityisesti indeksi
 *
 *-- 20) Nyt on aika miettiä silmukkaa.  Jos jonosta poistetaan kirjain,
 *       niin saako sillä kertaa siirtyä seuraavaan paikkaan jos jonoa mennään
 *       indeksin avulla  (yksi)
 *         en tiedä
 *         ei
 *         kyllä
 *         ei väliä
 *         |40|1|1|0|0|2;1
 *
 *-- 21) Valitaanko silmukaksi nyt  (yksi)
 *         for
 *         while
 *         do-while
 *         if ja goto
 *         |30|1|1|0|0|2;1
 *
 *
 *   Lisää apumuuttujat int i=0 ja int lkm=0 ja aloita while()-kirjoittaminen
 *
 *-- 22) While-silmukan ehto  (yksi)
 *        ( i < jono.Length )
 *        ( lkm < maxMaara )
 *        ( i < jono.Length && lkm < maara )
 *        ( i < jono.Length or lkm < maara )
 *        |40|1|1|0|0|3;1
 *
 *   Lisää ehto ( i < jono.Length && lkm < maara ) {
 *
 *   ja silmukan sisään q20
 *   TYYPPI merkki = jono[i];
 *
 *-- 23) Mikä tyyppi  (yksi)
 *        static
 *        int
 *        public
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        char
 *        |30|1|1|0|0|8;1
 *
 *    Kirjoita TYYPPIn tilalle char
 *
 *-- 24) Miten katsotaan onko merkki joukossa siirrettavat (yksi)
 *        for-silmukalla
 *        if ( siirrettavat.IndexOf(merkki) >= 0 )
 *        if ( siirrettavat[0] == merkki  )
 *        if ( siirrettavat[i] == merkki  )
 *        if ( siirrettavat[0-length] <= merkki )
 *        |40|1|1|0|0|2;1
 *
 *   Lisää rivin merkki = jälkeen  q21
 *    if ( siirrettavat.IndexOf(merkki) >= 0 ) {
 *        jono.Remove(i,1);
 *
 *    Lisää silmukan ulkopuolelle
 *     TYYPPI tulos = ;
 *
 *-- 25) Jos merkki on poistettavia, niin se pitäisi lisätä tulos-jonoon.
 *       Mikä olisi tulosjonon tyyppi (yksi)
 *        ei mitään
 *        int
 *        char
 *        private 
 *        string
 *        void
 *        bool
 *        StringBuilder
 *        |30|1|1|0|0|8;1
 *
 *    Muuta silmukan ulkopuolelle
 *     StringBuilder tulos = new StringBuilder();
 *
 *--  26) Miten merkki lisätään tulosjonoon (yksi)
 *         tulos = merkki
 *         tulos += merkki
 *         tulos = tulos.Append(merkki)
 *         tulos.Append(merkki)
 *         tulos = new StringBuilder(tulos+merkki)
 *         |40|1|1|0|0|4;1
 *
 *     Lisää iffin sisälle tulos.Append(merkki)
 *
 *--  27) Merkin löytyessä pitää tehdä vielä (mahdollisesti monta)
 *         i = i + 1
 *         i++
 *         lkm++
 *         tulos = ""
 *         jono = ""
 *         return i
 *         |30|1|4|0|0|3;1
 *
 *    Lisää iffin sisälle lkm++
 *
 *--  28) Jos merkkiä ei löydy, pitää tehdä
 *         i = i - 1
 *         i++
 *         lkm++
 *         tulos = ""
 *         jono = ""
 *         return i
 *         |30|1|1|0|0|2;1
 *
 *     Lisää else osaan i++;
 *
 *--  29) Kun kaikki merkit on käyty läpi, seuraavaksi tehdään
 *         return i
 *         return tulos
 *         return tulos.ToString()
 *         return lkm
 *         |40|1|1|0|0|3;1
 *
 *     Lisää aliohjelman loppuun return tulos.toString()
 *
 *--  30) Aliohjelma on valmis.  Mitä tehdään seuraavaksi (yksi)
 *         en tiedä
 *         lähdetään syömään
 *         ajetaan testit
 *         todetaan että ohjelma on valmis
 *         |30|1|1|0|0|3;1
 *
 *     Aja testit.
 *     Aja pääohjelma
 *
 *--  31) Tarvittaisiinko lkm-muuttujaa lainkaan?
 *          en tiedä
 *          ei välttämättä
 *          tarvitaan
 *         |20|1|1|0|0|1;1
 *
 -- 32) Avoin:  Miten homman voisi hoitaa
 * </pre>
 */

/// @author  Vesa Lappalainen
/// @version 13.11.2011
/// <summary>
///  Kalevalasta täytyy laskea kunkin säkeen kolme ensimmäistä vokaalia.
/// </summary>
public class Siirra
{
    /// <summary>
    /// Poistetaan jonosta korkeintaan maara kappaletta joukon siirrettavat kirjaimia.
    /// </summary>
    /// <param name="jono">mistä poistetaan</param>         
    /// <param name="siirrettavat">mitä kirjaimia poistetaan</param> 
    /// <param name="maxMaara">montako korkeintaan poistetaan</param> 
    /// <returns>siirretyt merkit</returns> 
    /// <example>
    /// <pre name="test">
    ///   StringBuilder jono = new StringBuilder("kissa istuu");
    ///   SiirraKirjaimet(jono,"",1)    === "";    jono.ToString() === "kissa istuu";
    ///   SiirraKirjaimet(jono,"xyz",1) === "";    jono.ToString() === "kissa istuu";
    ///   SiirraKirjaimet(jono,"aus",0) === "";    jono.ToString() === "kissa istuu";
    ///   SiirraKirjaimet(jono,"i",1)   === "i";   jono.ToString() === "kssa istuu";
    ///   SiirraKirjaimet(jono,"s",2)   === "ss";  jono.ToString() === "ka istuu";
    ///   SiirraKirjaimet(jono,"aus",3) === "asu"; jono.ToString() === "k itu";
    ///   SiirraKirjaimet(jono,"iu",3)  === "iu";  jono.ToString() === "k t";
    ///   SiirraKirjaimet(jono," ",1)   === " ";   jono.ToString() === "kt";
    ///   SiirraKirjaimet(jono,"kt",5)  === "kt";  jono.ToString() === "";
    ///   SiirraKirjaimet(jono,"kt",5)  === "";    jono.ToString() === "";
    /// </pre>
    /// </example>
    public static string SiirraKirjaimet(StringBuilder jono, string siirrettavat, int maxMaara)
    {
        int i = 0;
        StringBuilder tulos = new StringBuilder();

        while (i < jono.Length && tulos.Length < maxMaara)
        {
            char merkki = jono[i];
            if (siirrettavat.IndexOf(merkki) >= 0)
            // if (siirrettavat.Contains(""+merkki) )
            {
                jono.Remove(i, 1);
                tulos.Append(merkki);
            }
            else
                i++;
        }
        return tulos.ToString();
    }


    /// <summary>
    /// Kokeillaan poistamisen toimivuutta
    /// </summary>
    public static void Main()
    {
        StringBuilder jono = new StringBuilder("Mieleni minun tekevi, aivoni ajattelevi");
        string vokaalit = "aeiouyåäö";
        int maara = 3;

        string jonon3EnsimmaistaVokaalia = SiirraKirjaimet(jono, vokaalit, maara);

        Console.WriteLine("Jono:  " + jono); // Mlni minun tekevi, aivoni ajattelevi
        Console.WriteLine("3 vok: " + jonon3EnsimmaistaVokaalia); // iee
    }
}
