﻿using Android.App;
using Android.Widget;
using Android.OS;
using Android.Runtime;
using AndroidX.AppCompat.App;

namespace AutolaskuriAndroid
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {
        private int ha = 0;
        private int ka = 0;

        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);

            TextView laskuriHA = FindViewById<TextView>(Resource.Id.laskuriHA);
            TextView laskuriKA = FindViewById<TextView>(Resource.Id.laskuriKA);
            Button buttonHA = FindViewById<Button>(Resource.Id.buttonHA);
            Button buttonKA = FindViewById<Button>(Resource.Id.buttonKA);
            Button buttonNollaa = FindViewById<Button>(Resource.Id.buttonNollaa);

            buttonHA.Click += (object sender, System.EventArgs e) =>
            {
                ha++;
                laskuriHA.Text = "" + ha;
            };

            buttonKA.Click += (object sender, System.EventArgs e) =>
            {
                ka++;
                laskuriKA.Text = "" + ka;
            };

            buttonNollaa.Click += (object sender, System.EventArgs e) =>
            {
                ha = ka = 0;
                laskuriHA.Text = laskuriKA.Text = "0";
            };
        }
        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }
}