﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Lajittelu
{
    /// @author  Vesa Lappalainen
    /// @version 05.11.2011
    /// <summary>
    /// Tutkitaan kokonaislukujen lajittelemiseen kuluvaa aikaa.
    /// Mittaukset tehty vesah3-koneella 6.11.2011.
    /// Verrattu Java ja C#:n lajiteluaikaa erilaisille taulukoille, joissa
    /// on ollut luvut järjestettynä etu ja takaperin, vähän erilaisia
    /// alkiota ja satunnainen täysin satunnainen määrä alkioita.
    /// Javassa on käytetty Arrays-luokan sort-metodia.
    /// C#:issa Array-luokan Sort-metodia.
    /// Lisäksi on tehty viritetty QuickSort, joka pyrkii nopeuteen
    /// taulukon lajitelluilla osilla. Tämä on merkitty testissä QS.
    /// n = taulukon koko. m = erilaisten taulukon alkioiden lukumäärä.
    /// Kaikissa testeissä on käytetty omatekoista generaattoria, joka
    /// tuottaa kielestä riippumatta samanlaisen taulukon.
    /// </summary>
    /// <remarks>
    /// <code>
    ///      n      m          Java Arrays    Java QS        C# Array        C# QS
    /// Järjestetty: ==================================================================
    ///        5         :       0      0      0      0        0      0       1      0
    ///       50         :       0      0      0      0        0      0       0      0
    ///      500         :       0      0      0      0        0      0       0      0
    ///     5000         :       7      1      1      0        0      0       0      0
    ///    50000         :       2      3      5      0        1      2       1      0
    ///   500000         :      21     21      2      0       48     12       1      1
    ///  5000000         :     240    240      5      5      232    141       8      8
    /// 50000000         :    2554   2557     91     41     1649   1660      83     80
    /// 
    /// Vähän erilaisia alkioita: =====================================================
    ///        5        5:       0             0               0              0
    ///       50        5:       0             0               0              0
    ///      500        5:       0             0               0              0
    ///     5000        5:       0             0               0              0
    ///    50000        5:       1             1               4              1
    ///   500000        5:       8            10              29              9
    ///  5000000        5:      83           100             333             90
    /// 50000000        5:     961          1025            3572            936
    /// 
    /// Satunnaisia lukuja: ===========================================================
    ///        5        5:       0             0               0              0
    ///       50       50:       0             0               0              0
    ///      500      500:       0             0               0              0
    ///     5000     5000:       1             1               1              1
    ///    50000    50000:       6            12               5              4
    ///   500000   500000:      74            60              57             54
    ///  5000000  5000000:     864           711             640            613
    /// 50000000 50000000:    9919          7852            7181           6956
    /// 
    /// Erilaisten alkioiden määrän vaikutus ==========================================
    /// 50000000        1:     140            41            3119             81
    /// 50000000        5:     952          1043            3586            933
    /// 50000000       50:    1980          1971            4203           1753
    /// 50000000      500:    3086          2963            4500           2569
    /// 50000000     5000:    4260          3785            4908           3323
    /// 50000000    50000:    5446          4771            5288           4136
    /// 50000000   500000:    6702          5912            5822           5269
    /// 50000000  5000000:    8376          7223            6696           6331
    /// 50000000 50000000:    9840          7838            7213           6914
    /// </code>
    /// Huomioita: C#:in valmis lajittelu häviää Javalle jos aineisto koostuu
    /// suuresta määrästä alkiota, joissa erilaisia ei ole kovin montaa ( n >> m ).
    /// Omatekoinen QS voittaa ylivoimaisesti jos taulukko
    /// on jo järjestyksessä. 
    /// 
    /// Geneerinen versio lajittelusta on hidas.  Long-lajittelu on hitaampi kuin Javassa.
    /// </remarks>
    /// 
    public class Mittaa
    {
        /// <summary>
        /// Kokeillaan miten kauan lajittelu kestää
        /// </summary>
        /// <param name="args"></param>
        public static void Main(string[] args)
        {
           IntLajittelu.IntMain(args);
           //LongLajittelu.LongMain(args);
           //GenLajittelu.GenMain(args);
        }


    }
}
