package Lajittelu;

/// @author  Vesa Lappalainen
/// @version 05.11.2011
/// <summary>
/// Tutkitaan kokonaislukujen lajittelemiseen kuluvaa aikaa
/// </summary>
public class LongLajittelu {
	// / <summary>
	// / Kokeillaan miten kauan lajittelu kest
	// / </summary>
	// / <param name="args">ei kytss</param>
	public static void main(String[] args) {
        System.out.println("\nJrjestetty: =================================");
        AjoitaJarjestetty(5);
        AjoitaJarjestetty(50);
        AjoitaJarjestetty(500);
        AjoitaJarjestetty(5000);
        AjoitaJarjestetty(50000);
        AjoitaJarjestetty(500000);
        AjoitaJarjestetty(5000000);
        AjoitaJarjestetty(50000000);

        System.out.println("\nVhn erilaisia alkioita: ====================");
        Ajoita(5, 5);
        Ajoita(50, 5);
        Ajoita(500, 5);
        Ajoita(5000, 5);
        Ajoita(50000, 5);
        Ajoita(500000, 5);
        Ajoita(5000000, 5);
        Ajoita(50000000, 5);

        System.out.println("\nSatunnaisia lukuja: ==========================");
        Ajoita(5, 5);
        Ajoita(50, 50);
        Ajoita(500, 500);
        Ajoita(5000, 5000);
        Ajoita(50000, 50000);
        Ajoita(500000, 500000);
        Ajoita(5000000, 5000000);
        Ajoita(50000000, 50000000);
        //Ajoita(500000000, 500000000);

        System.out.println("\nErilaisten alkioiden mrn vaikutus: ========");
        Ajoita(50000000, 1);
        Ajoita(50000000, 5);
        Ajoita(50000000, 50);
        Ajoita(50000000, 500);
        Ajoita(50000000, 5000);
        Ajoita(50000000, 50000);
        Ajoita(50000000, 500000);
        Ajoita(50000000, 5000000);
        Ajoita(50000000, 50000000);
	}

	
    /// <summary>
    /// Otetaan aikaa kun lajitellaan taulukko, jossa n kpl nousevasti
    /// ja laskevasti jrjestettyj alkioita.
    /// </summary>
    /// <param name="n">kuinka iso taulukko</param>
    public static void AjoitaJarjestetty(int n)
    {
        System.out.printf("%8d %8s: ", n, " ");
        int[] iluvut = utilities.RandomGen.Tayta(n, 0, -1, 1, 1);
        long[] luvut = new long[n];
        for (int i = 0; i < n; i++) luvut[i] = iluvut[i];
        iluvut = null;
        System.gc();
        utilities.StopTimer timer = new utilities.StopTimer();
        Jarjesta(luvut);
        System.out.printf("%7d", timer.lap());
		Tarkista(luvut);
        iluvut = utilities.RandomGen.Tayta(n, 0, -1, 1, 1);
        for (int i = 0; i < n; i++) luvut[i] = iluvut[i];
        iluvut = null;
        System.gc();
        timer.start();
        Jarjesta(luvut);
        System.out.printf("%7d\n", timer.lap());
		Tarkista(luvut);
    }


	// / <summary>
	// / Otetaan aikaa kun lajitellaan taulukko, jossa n kpl n erilaista alkiota
	// / </summary>
	// / <param name="n">kuinka iso taulukko</param>
	// / <param name="m">montako </param>
	public static void Ajoita(int n, int m) {
        System.out.printf("%8d %8d: ", n, m);
		int[] iluvut = utilities.RandomGen.Tayta(n, m);
        long[] luvut = new long[n];
        for (int i = 0; i < n; i++) luvut[i] = iluvut[i];
        iluvut = null;
		System.gc();
		utilities.StopTimer timer = new utilities.StopTimer();
		//timer.printLap(String.format("%8d %8d: ", n, m));
		Jarjesta(luvut);
        System.out.printf("%7d\n", timer.lap());
		Tarkista(luvut);
	}

	
	/// <summary>
	/// Lajitellaan taulukko
	/// </summary>
	/// <param name="luvut">lajiteltava taulukko</param>
	public static void Jarjesta(long[] luvut)
	{
	    //Arrays.sort(luvut);
	    QuickSort(luvut);
	}

	
    /// <summary>
    /// Tarkistaa onko taulukko jrjestyksess
    /// </summary>
    /// <param name="luvut">tarkistettava taulukko</param>
    public static void Tarkista(long[] luvut)
    {
	    for (int i = 0; i < luvut.length - 1; i++)
	        if (luvut[i] > luvut[i + 1]) {
	        	System.out.printf("VRIN: %d > %d\n", luvut[i], luvut[i + 1]);
	        	return;
	        }
    }

	
    /// <summary>
    /// Lajitellaan taulukko kytten rekursiivista QuickSorttia
    /// </summary>
    /// <param name="a">lajiteltava taulukko, taulukko muuttuu</param>
    /// <returns>viite lajiteltuun taulukkoon</returns>
    /// <example>
    /// <pre name="test">
    ///   int[] luvut = {3,6,2,9,3,1};
    ///   IntLajittelu.QuickSort(luvut);
    ///   String.Join(" ",luvut) === "1 2 3 3 6 9";
    /// </pre>
    /// </example>
    public static void QuickSort(long[] a)
    {
        QuickSort(a, 0, a.length - 1);
    }


    /// <summary>
    /// Lajitellaan osataulukko vlilt [alku,loppu]
    /// </summary>
    /// <param name="a">lajiteltava taulukko, muuttuu</param>
    /// <param name="alku">lajitteltavan alueen alku</param>
    /// <param name="loppu">alueen loppu</param>
    /// <returns>viite lajiteltuun taulukkoon</returns>
    /// <example>
    /// <pre name="test">
    ///   int[] luvut = {3,6,2,9,3,1};
    ///   IntLajittelu.QuickSort(luvut,0,2);
    ///   String.Join(" ",luvut) === "2 3 6 9 3 1";
    /// </pre>
    /// </example>
    public static void QuickSort(long[] a, int alku, int loppu)
    {
        while (alku < loppu)
        {
            if (Check(a, alku, loppu)) return;
            int q = Partition(a, alku, loppu);
            QuickSort(a, alku, q);
            //QuickSort(a, q + 1, loppu); // Vaihdetaan hntrekursioksi, niin pino riitt
            alku = q + 1;
        }
    }


    /// <summary>
    /// Tarkistetaan ett onko taulukon osa jrjestyksess.
    /// Aluksi katsotaan 2,3,4 kokoiset erikoistapauksena ja jrjestettn ne.
    /// Isomista palautetaan vain tieto ett onko taulukko jrjestetty vai ei.
    /// </summary>
    /// <param name="a">tutkittava taulukko, sislt voi muuttua</param>
    /// <param name="alku">tarkastelun alkuindeksi</param>
    /// <param name="loppu">tarkastelun loppuindeksi</param>
    /// <returns>true jos taulukko jrjestyksess.</returns>
    /// <example>
    /// <pre name="test">
    ///   int[] luvut = {1,2};
    ///   IntLajittelu.Check(luvut,0,1) === true;
    ///   luvut = new int[]{2,1};
    ///   IntLajittelu.Check(luvut,0,1) === true;
    ///   string.Join(" ",luvut) === "1 2";
    ///   luvut = new int[]{1,2,3};
    ///   IntLajittelu.Check(luvut,0,2) === true;
    ///   luvut = new int[]{3,1,2};
    ///   IntLajittelu.Check(luvut,0,2) === true;
    ///   string.Join(" ",luvut) === "1 2 3";
    ///   luvut = new int[]{1,2,3,4};
    ///   IntLajittelu.Check(luvut,0,3) === true;
    ///   luvut = new int[]{3,1,4,2};
    ///   IntLajittelu.Check(luvut,0,3) === true;
    ///   string.Join(" ",luvut) === "1 2 3 4";
    ///   luvut = new int[]{3,1,5,4,2};
    ///   IntLajittelu.Check(luvut,0,4) === false;
    ///   string.Join(" ",luvut) === "3 1 5 4 2";
    /// </pre>
    /// </example>
    public static boolean Check(long[] a, int alku, int loppu)
    {
        switch (loppu - alku)
        {
            case 1:
                {
                    long a1 = a[alku];
                    long a2 = a[loppu];
                    if (a1 <= a2) return true;
                    a[alku] = a2;
                    a[loppu] = a1;
                    return true;
                }
            case 2:
                {
                    long a1 = a[alku];
                    long a2 = a[alku + 1];
                    long a3 = a[loppu];
                    if (a1 <= a2 && a2 <= a3) return true;
                    if (a1 > a2) { a1 = a2; a2 = a[alku]; }
                    if (a2 > a3) { a[loppu] = a2; a2 = a3; }
                    if (a1 > a2) { a[alku] = a2; a[alku + 1] = a1; }
                    else { a[alku] = a1; a[alku + 1] = a2; }
                    return true;
                }
            case 3:
                {
                	long a1 = a[alku];
                	long a2 = a[alku + 1];
                	long a3 = a[loppu - 1];
                	long a4 = a[loppu];
                    if (a1 <= a2 && a2 <= a3 && a3 <= a4) return true;
                    if (a1 > a2) { a1 = a2; a2 = a[alku]; }
                    if (a2 > a3) { a3 = a2; a2 = a[loppu - 1]; }
                    if (a3 > a4) { a[loppu] = a3; a3 = a4; }
                    a[loppu - 1] = a3;
                    if (a1 > a2) { long tmp = a1; a1 = a2; a2 = tmp; }
                    if (a2 > a3) { a[loppu - 1] = a2; a2 = a3; }
                    if (a1 > a2) { a[alku] = a2; a[alku + 1] = a1; }
                    else { a[alku] = a1; a[alku + 1] = a2; }
                    return true;
                }
        }
        for (int i = alku; i < loppu; i++)
            if (a[i] > a[i + 1]) return false;
        return true;
    }

    /// <summary>
    /// Etsitn jakopaikka (pivot).  Eli alkio, jonka vasemmalla
    /// puolella kaikki ovat alkiota pienempi ja oikealla puolella
    /// suurempia. Etsinnn aikana vaihdetaan alkioiden paikkoja.
    /// </summary>
    /// <param name="a">tutkittava taulukko</param>
    /// <param name="vasen">osan alku</param>
    /// <param name="oikea">osan loppu</param>
    /// <returns>jakopaikka</returns> 
    /// <example>
    /// <pre name="test">
    ///   int[] luvutj = {1,2,3,4,5,6,7,8,9};
    ///   IntLajittelu.Partition(luvutj,0,8) === 4;
    ///   String.Join(" ",luvutj) === "1 2 3 4 5 6 7 8 9";
    ///   int[] luvut = {3,7,8,5,2,1,9,5,4};
    ///   IntLajittelu.Partition(luvut,0,8) === 1;
    ///   String.Join(" ",luvut) === "1 2 8 5 7 3 9 5 4";
    /// </pre>
    /// </example>
    public static int Partition(long[] a, int vasen, int oikea)
    {
        int pivotIndex = (vasen + oikea) / 2;
        // int pivotIndex = vasen; // huono jrjestetylle joukolle
        // int pivotIndex = MiidiIndex(a, vasen, oikea); // nostaa kerrointa koska hidasta
        /* // Etistn kolmen luvun mediaani, ei paljonkaan auta
        int i0 = vasen;
        int i1 = pivotIndex;
        int i2 = oikea;
        if (a[i0] > a[i1]) { i0 = pivotIndex; i1 = vasen; }
        if (a[i1] > a[i2]) { i2 = i1; i1 = oikea; }
        if (a[i0] > a[i1]) { i1 = i0; }
        pivotIndex = i1;
        */

        long pivotValue = a[pivotIndex];
        int iv = vasen - 1;
        int io = oikea + 1;
        long tmp = 0;
        while (true)
        {
            do
            {
                io--;
            } while (a[io] > pivotValue);
            do
            {
                iv++;
            } while (a[iv] < pivotValue);

            if (iv >= io) return io;

            tmp = a[iv];
            a[iv] = a[io];
            a[io] = tmp;
        }
    }
    
    
}





