package utilities;

    /// <summary>
    /// Luokka luokalle, jolla voidaan ottaa aikoja
    /// </summary>
    public class StopTimer
    {
        private long start;
        private long lastLap;

        /// <summary>
        /// Onko tulostukset pll vai ei.
        /// </summary>
        public static boolean printOff;

        /// <summary>
        /// Alustetaan luokka ja aloitetaan ajanotto
        /// </summary>
        public StopTimer()
        {
            start();
        }


        /// <summary>
        /// Aloitetaan ajanotto
        /// </summary>
        public void start()
        {
            start = System.currentTimeMillis();
            lap();
        }


        /// <summary>
        /// Palauttaa ajan edellisest kutsusta ms
        /// </summary>
        /// <returns>aika edellisest kutsusta ms</returns>
        public long lap()
        {
            long t = time();
            long clap = t - lastLap;
            lastLap = t;
            return clap;
        }


        /// <summary>
        /// Palauttaa ajan ajastimen kynnistyksest
        /// </summary>
        /// <returns>aika kynnistyksest ms</returns>
        public long time()
        {
            return System.currentTimeMillis() - start;
        }


        /// <summary>
        /// Tulostaa ajan ja vliajan
        /// </summary>
        /// <param name="msg">tulostuksen alkuun tuleva viesti</param>
        public void printLap(String msg)
        {
            if (printOff) return;
            long t = time();
            long clap = lap();
            System.out.printf("%s%7d%7d\n", msg, t, clap);
        }
        
        public void printLap()
        {
        	printLap("");
        }

    }
