﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Utilities
{
    /// <summary>
    /// Luokka luokalle, jolla voidaan ottaa aikoja
    /// </summary>
    public class StopTimer
    {
        private DateTime start;
        private double lastLap;

        /// <summary>
        /// Onko tulostukset päällä vai ei.
        /// </summary>
        public static bool PrintOff { get; set; }

        /// <summary>
        /// Alustetaan luokka ja aloitetaan ajanotto
        /// </summary>
        public StopTimer()
        {
            Start();
        }


        /// <summary>
        /// Aloitetaan ajanotto
        /// </summary>
        public void Start()
        {
            start = System.DateTime.Now;
            Lap();
        }


        /// <summary>
        /// Palauttaa ajan edellisestä kutsusta ms
        /// </summary>
        /// <returns>aika edellisestä kutsusta ms</returns>
        public double Lap()
        {
            double t = Time();
            double lap = t - lastLap;
            lastLap = t;
            return lap;
        }


        /// <summary>
        /// Palauttaa ajan ajastimen käynnistyksestä
        /// </summary>
        /// <returns>aika käynnistyksestä ms</returns>
        public double Time()
        {
            return (System.DateTime.Now - start).TotalMilliseconds;
        }


        /// <summary>
        /// Tulostaa ajan ja väliajan
        /// </summary>
        /// <param name="msg">tulostuksen alkuun tuleva viesti</param>
        public void PrintLap(string msg = "")
        {
            if (PrintOff) return;
            double t = Time();
            double lap = Lap();
            Console.WriteLine("{0}{1,7:0}{2,7:0}", msg, t, lap);
        }
    }
}
